unit menufx;
interface
uses crt,dos;

type t_zeichen = record
       buchstabe:byte;
       farbe    :byte;
     end;
     t_fenster = record
       adresse : pointer;
       x1:byte;
       y1:byte;
       x2:byte;
       y2:byte;
       v_farbe:byte;
       h_farbe:byte;
       dicke:byte;
       shadow:boolean;
     end;
     t_menu_string = string[32];
     t_unter_menu = record
       titel  : t_menu_string;
       befehl : array[0..9] of t_menu_string;
     end;
     t_menu = record
       leiste : array[0..9] of t_unter_menu;
       last_titel : byte;
     end;
     t_bildschirm = array[0..24,0..79] of t_zeichen;

var
  v_ram     : t_bildschirm absolute $b800:0000;
  v_shaddow : t_bildschirm;
  orig_mode : integer;

const
  {Farben:  }
  schwarz   =0;   blau      =1;
  grun      =2;   turkis    =3;
  rot       =4;   fuchsrot  =5;
  braun     =6;   hellgrau  =7;
  dunkelgrau=8;   hellblau  =9;
  hellgrun  =10;  hellturkis=11;
  hellrot   =12;  hellfuchsrot=13;
  gelb      =14;  weiss     =15;

procedure menufx_init;
procedure menufx_exit;
procedure set_chr(x,y,ascii,v_farbe,h_farbe:byte);
function  get_chr(x,y:byte):byte;
procedure waitkey;
procedure strich(x1,y1,x2,y2,ascii,v_farbe,h_farbe:byte);
procedure rahmen(x1,y1,x2,y2,dicke,v_farbe,h_farbe:byte);
procedure block(x1,y1,x2,y2,ascii,v_farbe,h_farbe:byte);
procedure fensterauf(var fenster:t_fenster);
procedure fensterzu(fenster:t_fenster);
procedure cursoraus;
procedure cursoran;
procedure cursornormal;
procedure gross(var quelle:string);
function  input_string(x,y,max:byte;txt:string):string;
function  get_string(text,vorgabe:string):string;
procedure warnung(text:string);
function  dialogbox(text:string):boolean;
procedure option_box(var b1,b2,b3,b4,b5:boolean;titel,s1,s2,s3,s4,s5:string;anzahl:byte);
function  dateiwahl(filter,pfad,text:string):string;
procedure del_menu(var m:t_menu);
procedure get_menu(m:t_menu;var titel,befehl:byte);
function  select_box(titel,t1,t2,t3,t4,t5:t_menu_string):byte;

Implementation

procedure menufx_init;
begin
  orig_mode:=lastmode;
  textmode(3);
  clrscr;
end;

procedure menufx_exit;
begin
  textmode(orig_mode);
  clrscr;
end;

procedure set_chr(x,y,ascii,v_farbe,h_farbe:byte);
begin
  v_ram[y,x].buchstabe:=ascii;
  v_ram[y,x].farbe    :=v_farbe+(h_farbe shl 4);
end;

function get_chr(x,y:byte):byte;
begin
  get_chr:=v_ram[y,x].buchstabe;
end;

procedure waitkey;
var ch:char;
begin
while not keypressed do;
ch:=readkey;
if ch=#0 then ch:=readkey;
end;

procedure strich(x1,y1,x2,y2,ascii,v_farbe,h_farbe:byte);
var x,y:byte;
begin
  if x2<x1 then begin x:=x1;
                     x1:=x2;
                     x2:=x;
                     y:=y1;
                     y1:=y2;
                     y2:=y;end;
  if y2<y1 then begin x:=x1;
                     x1:=x2;
                     x2:=x;
                     y:=y1;
                     y1:=y2;
                     y2:=y;end;
  if x1=x2 then for y:=y1 to y2 do set_chr(x1,y,ascii,v_farbe,h_farbe);
  if y1=y2 then for x:=x1 to x2 do set_chr(x,y1,ascii,v_farbe,h_farbe);
end;

procedure rahmen(x1,y1,x2,y2,dicke,v_farbe,h_farbe:byte);
var x,y:byte;
begin
  case dicke of
    0 :begin
       strich(x1,y1,x1,y2,219,v_farbe,h_farbe);
       strich(x1,y1,x2,y1,219,v_farbe,h_farbe);
       strich(x2,y2,x1,y2,219,v_farbe,h_farbe);
       strich(x2,y2,x2,y1,219,v_farbe,h_farbe);
       end;
    1 :begin
         strich(x1,y1,x1,y2,179,v_farbe,h_farbe);
         strich(x1,y1,x2,y1,196,v_farbe,h_farbe);
         strich(x2,y2,x1,y2,196,v_farbe,h_farbe);
         strich(x2,y2,x2,y1,179,v_farbe,h_farbe);
         set_chr(x1,y1,218,v_farbe,h_farbe);
         set_chr(x2,y2,217,v_farbe,h_farbe);
         set_chr(x1,y2,192,v_farbe,h_farbe);
         set_chr(x2,y1,191,v_farbe,h_farbe);
       end;

    2 :begin
         strich(x1,y1,x1,y2,186,v_farbe,h_farbe);
         strich(x1,y1,x2,y1,205,v_farbe,h_farbe);
         strich(x2,y2,x1,y2,205,v_farbe,h_farbe);
         strich(x2,y2,x2,y1,186,v_farbe,h_farbe);
         set_chr(x1,y1,201,v_farbe,h_farbe);
         set_chr(x2,y2,188,v_farbe,h_farbe);
         set_chr(x1,y2,200,v_farbe,h_farbe);
         set_chr(x2,y1,187,v_farbe,h_farbe);
       end;
  end;
end;

procedure blockschatten(x1,y1,x2,y2:byte);
var x,y:byte;
begin
  for x:=x1 to x2 do
    for y:=y1 to y2 do
      v_ram[y,x].farbe:=hellgrau;
end;

procedure block(x1,y1,x2,y2,ascii,v_farbe,h_farbe:byte);
var x,y:byte;
begin
  for x:=x1 to x2 do
    for y:=y1 to y2 do
      set_chr(x,y,ascii,v_farbe,h_farbe);
end;

procedure draw_fenster(x1,y1,x2,y2,dicke,v_farbe,h_farbe:byte);
begin
  block(x1,y1,x2,y2,32,v_farbe,h_farbe);
  rahmen(x1,y1,x2,y2,dicke,v_farbe,h_farbe);
end;

procedure fensterauf(var fenster:t_fenster);
var grosse,lange,hohe,seg1,seg2,ofs1,ofs2:word;
    x,y:byte;

begin
  with fenster do begin
    if (x2<78) and (y2<24) and shadow then shadow:=true else shadow:=false;
    if shadow then
      begin
      inc(x2,2);
      inc(y2);
      end;
    lange:=succ(x2-x1)*2;
    hohe:=succ(y2-y1);
    grosse :=lange*hohe;
    getmem(adresse,grosse);
    seg1:=seg(adresse^);
    ofs1:=ofs(adresse^);
    seg2:=$b800;
    ofs2:=0;
    inc(ofs2,(160*y1+(x1 shl 1)));
    for y:=y1 to y2 do
       begin
       move(ptr(seg2,ofs2)^,ptr(seg1,ofs1)^,lange);
       inc(ofs1,lange);
       inc(ofs2,160);
       end;

    if shadow then
      begin
      dec(x2,2);
      dec(y2);
      blockschatten(x1+2,y1+1,x2+2,y2+1);
      end;

    draw_fenster(x1,y1,x2,y2,dicke,v_farbe,h_farbe);
    if shadow then begin
      inc(x2,2);
      inc(y2);
      end;
  end;
end;

procedure fensterzu(fenster:t_fenster);
var grosse,lange,seg1,seg2,ofs1,ofs2:word;
    x,y:byte;
begin
  with fenster do begin
    lange:=succ(x2-x1)*2;
    grosse :=lange*succ(y2-y1);
    seg1:=seg(adresse^);
    ofs1:=ofs(adresse^);
    seg2:=$b800;
    ofs2:=0;
    inc(ofs2,(160*y1+(x1 shl 1)));
    for y:=y1+1 to y2+1 do
       begin
       move(ptr(seg1,ofs1)^,ptr(seg2,ofs2)^,lange);
       inc(ofs1,lange);
       inc(ofs2,160);
       end;
    freemem(adresse,grosse);
  end;
end;

procedure cursoraus;assembler;
asm
  mov ah,1
  mov ch,255
  mov cl,255
  int 10h
end;

procedure cursoran;assembler;
asm
  mov ah,1
  mov ch,1
  mov cl,8
  int 10h
end;

procedure cursornormal;assembler;
asm
  mov ah,1
  mov ch,7
  mov cl,8
  int 10h
end;

procedure suche_ersetze(var quelle:string; suche,ersatz:string);
var x:byte;
begin
  while pos(suche,quelle)<>0 do begin
    x:=pos(suche,quelle);
    delete(quelle,x,length(suche));
    insert(ersatz,quelle,x);
  end;
end;


function input_string(x,y,max:byte;txt:string):string;
var c:char;
    ende,steuer:boolean;
    z,cursor,zeiger:byte;
    htxt:string;

begin
  ende:=false;
  cursor:=length(txt)+1;
  zeiger:=1;
  gotoxy(x,y);
  repeat
    gotoxy(x,y);
    htxt:=copy(txt,zeiger,max);
    write(htxt);
    for z:=ord(htxt[0]) to max do write(' ');
    gotoxy(x+cursor-zeiger,y);
    cursoran;
    repeat until keypressed;
    cursoraus;
    steuer:=false;
    c:=readkey;
    if c=#0 then begin c:=readkey;
                      steuer:=true;
                end;
    if not steuer then
      case c of
      #27 : ende:=true;
      #13 : ende:=true;
      #8  : if cursor >1 then begin
              dec(cursor);
              delete(txt,cursor,1);
            end;
      else begin
             txt:=copy(txt,1,cursor-1)+c+copy(txt,cursor,length(txt)-cursor+1);
             inc(cursor);
           end;
      end
      else
        case c of
          'M' : if cursor < (ord(txt[0])+1) then inc(cursor);
          'K' : if cursor > 1 then dec(cursor);
          'G' : begin cursor:=1;zeiger:=1;end;
          'O' : begin cursor:=ord(txt[0]);zeiger:=cursor-(max)+1;end;
          'S' : delete(txt,cursor,1);
        end;
      if (cursor > zeiger+(max))and(zeiger<(255-max)) then inc(zeiger);
      if (cursor < zeiger+1)and(zeiger>1) then dec(zeiger);
  until ende;
  if c<>#27 then input_string:=txt else input_string:='';
end;

function get_string(text,vorgabe:string):string;
var l,x1,x2,x:byte;
    flak:boolean;
    ch:char;
    fenster:t_fenster;
begin
  l:=length(text);
  if l<32 then begin
     x1:=21;
     x2:=57;
     x:=x1+18-(l shr 1);
  end
  else begin
     x1:=37-(l shr 1);
     x2:=41+(l shr 1);
     x:=x1+3;
     
  end;
  fenster.x1:=x1;
  fenster.y1:=8;
  fenster.x2:=x2;
  fenster.y2:=14;
  fenster.v_farbe:=weiss;
  fenster.h_farbe:=hellgrau;
  fenster.dicke:=2;
  fenster.shadow:=true;
  fensterauf(fenster);

  textcolor(schwarz);
  textbackground(hellgrau);
  gotoxy(x,11);
  write (text);
  textbackground(turkis);
  gotoxy(24,13);
  write('                             ');
  get_string:=input_string(24,13,32,vorgabe);
  fensterzu(fenster);
end;


procedure warnung(text:string);
var fenster:t_fenster;
    x1,x2,x,l:byte;
begin
  l:=length(text);
  if l<20 then begin
     x1:=30;
     x2:=50;
     x:=x1+10-(l shr 1);
  end
  else begin
     x1:=38-(l shr 1);
     x2:=42+(l shr 1);
     x:=x1+2;
  end;
  fenster.x1:=pred(x1);
  fenster.x2:=pred(x2);
  fenster.y1:=9;
  fenster.y2:=13;
  fenster.v_farbe:=weiss;
  fenster.h_farbe:=hellgrau;
  fenster.dicke:=2;
  fenster.shadow:=true;
  fensterauf(fenster);
  gotoxy(x,12);
  textcolor(rot);
  textbackground(hellgrau);
  write(text+#7);
  waitkey;
  fensterzu(fenster);
end;

function dialogbox(text:string):boolean;
var l,x1,x2,x:byte;
    flak:boolean;
    ch:char;
    fenster:t_fenster;
begin
  l:=length(text);
  if l<20 then begin
     x1:=30;
     x2:=50;
     x:=x1+10-(l shr 1);
  end
  else begin
     x1:=38-(l shr 1);
     x2:=42+(l shr 1);
     x:=x1+2;
  end;
  flak:=true;
  fenster.x1:=pred(x1);
  fenster.x2:=pred(x2);
  fenster.y1:=8;
  fenster.y2:=14;
  fenster.v_farbe:=weiss;
  fenster.h_farbe:=hellgrau;
  fenster.dicke:=2;
  fenster.shadow:=true;
  fensterauf(fenster);
  textcolor(schwarz);
  textbackground(hellgrau);
  gotoxy(x,11);
  write (text);
  textcolor(schwarz);
  repeat
    begin
      textbackground(turkis);
      if flak then
        begin
          gotoxy(33,13);
          write('  Ja  ');
          textbackground(hellgrau);
          gotoxy(42,13);
          write(' Nein ');
        end
      else
        begin
          gotoxy(42,13);
          write(' Nein ');
          textbackground(hellgrau);
          gotoxy(33,13);
          write('  Ja  ');
        end;
    ch:=readkey;
    if ch = #0 then ch:=readkey;
    if (ch = #75) or (ch =#77) or (ch=#9) then flak:=not flak;
    end;
  until (ch = #13)or (ch=#27);
  if ch=#13 then dialogbox:=flak else dialogbox:=false;
  fensterzu(fenster);
end;

procedure option_box(var b1,b2,b3,b4,b5:boolean;titel,s1,s2,s3,s4,s5:string;anzahl:byte);
type t_option = record
       wert:boolean;
       name:string;
     end;

var fenster:t_fenster;
    daten : array[0..4] of t_option;
    ch:char;
    z:byte;

begin
  with daten[0] do begin wert:=b1;name:=s1;end;
  with daten[1] do begin wert:=b2;name:=s2;end;
  with daten[2] do begin wert:=b3;name:=s3;end;
  with daten[3] do begin wert:=b4;name:=s4;end;
  with daten[4] do begin wert:=b5;name:=s5;end;
  fenster.x1:=28;
  fenster.y1:=(21-anzahl) div 2;
  fenster.x2:=fenster.x1+24;
  fenster.y2:=fenster.y1+anzahl+4;
  fenster.v_farbe:=weiss;
  fenster.h_farbe:=hellgrau;
  fenster.dicke:=1;
  fenster.shadow:=true;
  fensterauf(fenster);
  gotoxy(fenster.x1+3,fenster.y1+2);
  textcolor(schwarz);
  textbackground(hellgrau);
  write(titel);
  for z:=0 to pred(anzahl) do
    begin
    gotoxy(fenster.x1+3,fenster.y1+4+z);
    write('[');
    if daten[z].wert then write('X') else write(' ');
    write('] ',daten[z].name);
    end;
  z:=0;
  repeat
    textcolor(weiss);
    gotoxy(fenster.x1+3,fenster.y1+4+z);
    write('[');
    if daten[z].wert then write('X') else write(' ');
    write('] ',daten[z].name);
    while not keypressed do;
    ch:=readkey;
    if ch=#0 then ch:=readkey;
    if (ch='H') or (ch='P') then
      begin
      textcolor(schwarz);
      gotoxy(fenster.x1+3,fenster.y1+4+z);
      write('[');
      if daten[z].wert then write('X') else write(' ');
      write('] ',daten[z].name);
      if ch='H' then dec(z) else inc(z);
      if z= 255 then z:=pred(anzahl);
      if z=anzahl then z:=0;
      end;
    if ch=' ' then begin
      daten[z].wert:= not daten[z].wert;
      textcolor(weiss);
      gotoxy(fenster.x1+3,fenster.y1+4+z);
      write('[');
      if daten[z].wert then write('X') else write(' ');
      end;
  until (ch=#13) or (ch=#27);
  fensterzu(fenster);
  if ch=#13 then begin
    with daten[0] do b1:=wert;
    with daten[1] do b2:=wert;
    with daten[2] do b3:=wert;
    with daten[3] do b4:=wert;
    with daten[4] do b5:=wert;
  end;
end;

procedure gross(var quelle:string);
var x:byte;
begin
  for x:=1 to length(quelle) do quelle[x]:=upcase(quelle[x]);
end;

function dateiwahl(filter,pfad,text:string):string;

type t_dateien = record
       name  : array[0..255] of string[13];
       anzahl : byte;
     end;
var
    fenster : t_fenster;
    dateien : t_dateien;
    max_pos,akut_pos,akut_set,z:word;
    neue_dateien,ende : boolean;
    ch: char;

label pfadwechsel;

procedure erweitern(var s:string);
begin
  while length(s)<>12 do s:=s+' ';
end;

procedure kurze(var p:string);
begin
  while p[length(p)]<>'\' do delete(p,length(p),1);
  delete(p,length(p),1);
end;

procedure zeigefiles (pos,akut:byte);
var z: byte;
begin
  z:=pos;
  textcolor(black);
  textbackground(turkis);
  if dateien.anzahl<>0 then begin
    while (z<=dateien.anzahl)and((z-pos)<11) do
      begin
      gotoxy(18,z+9-pos);
      write(dateien.name[z]);
      inc(z);
      end;
    gotoxy(18,9+akut-pos);
    textcolor(gelb);
    write(dateien.name[akut]);
    end
  else
    begin
    textcolor(rot);
    gotoxy(18,9);
    write('Keine');
    gotoxy(18,10);
    write('Eintrge');
    end;
  if pos > 0 then z:=30 else z:=254;
  set_chr(31,8,z,schwarz,turkis);
  if pos+10 < dateien.anzahl then z:=31 else z:=254;
  set_chr(31,18,z,schwarz,turkis);


end;

procedure get_files(filter,pfad:string);
var dir_rec : SearchRec;
begin
  dateien.anzahl:=0;
  findfirst(pfad+'\*.*',16,dir_rec);
  while (doserror = 0 ) and (dateien.anzahl<255) do
  begin
    erweitern(dir_rec.name);
    if dir_rec.attr=16 then
      begin
      dateien.name[dateien.anzahl]:='>'+dir_rec.name;
      inc(dateien.anzahl);
      end;
    findNext(Dir_rec);
  end;

  findfirst(pfad+'\'+filter,0,dir_rec);
  while (doserror = 0 ) and (dateien.anzahl<255) do
  begin
      erweitern(dir_rec.name);
      dateien.name[dateien.anzahl]:=' '+dir_rec.name;
      inc(dateien.anzahl);
      findNext(Dir_rec);
  end;
  if dateien.anzahl<>0 then dec(dateien.anzahl);
end;


begin;
  fenster.x1:=13;
  fenster.y1:=4;
  fenster.x2:=57;
  fenster.y2:=20;
  fenster.v_farbe:=weiss;
  fenster.h_farbe:=hellgrau;
  fenster.dicke:=1;
  fenster.shadow:=true;
  fensterauf(fenster);
  textcolor(schwarz);
  textbackground(hellgrau);
  gotoxy(17,7);
  write(text);
  dateiwahl:='';
  textbackground(7);
  textcolor(15);
  gotoxy(35,9) ;write('Pfad   :');
  gotoxy(35,12);write('Filter :');
  gotoxy(35,15);Write('F1  - Neuer Pfad     ');
  gotoxy(35,17);Write('F2  - Neuer Filter   ');
  gotoxy(35,19);Write('ESC - zurck');
  block(16,8,31,18,32,schwarz,turkis);
  strich(31,8,31,18,179,schwarz,turkis);
  {rahmen(16,7,31,19,1,schwarz,turkis);}
  ende:=false;
  neue_dateien:=true;
  while not ende do
    begin
    if neue_dateien then
      begin
      block(17,8,30,18,32,schwarz,turkis);
      if pfad[length(pfad)]='\' then delete(pfad,length(pfad),1);
      get_files(filter,pfad);
      akut_pos:=0;
      akut_set:=0;
      if dateien.anzahl > 10 then
        max_pos:=dateien.anzahl-10
      else
        max_pos:=0;
      neue_dateien:=false;
      textcolor(schwarz);
      textbackground(turkis);

      gotoxy(35,10) ;write('                     ');
      gotoxy(35,10) ;write(copy(pfad,1,20));
      gotoxy(35,13) ;write('             ');
      gotoxy(35,13);write(copy(filter,1,12));
      end;
    zeigefiles(akut_set,akut_pos);
    while not keypressed do;
    ch:=readkey;
    if ch=#0 then ch:=readkey;
    case ch of
      #72 : begin {hoch}
            if akut_pos>0 then dec(akut_pos);
            if akut_pos<akut_set then dec(akut_set);
            end;
      #80 : begin {runter}
            if akut_pos<dateien.anzahl then inc(akut_pos);
            if (akut_pos>(akut_set+10))and (akut_set < max_pos) then inc(akut_set);
            end;
      #59 : begin {f1}
            textcolor(schwarz);
            textbackground(turkis);
            pfad:=input_string(35,10,20,pfad);
            gross(pfad);
            if pfad[length(pfad)]='\' then delete(pfad,length(pfad),1);
            neue_dateien:=true;
            end;
      #60 : begin {f2}
            textcolor(schwarz);
            textbackground(turkis);
            filter:=input_string(35,13,12,filter);
            gross(filter);
            neue_dateien:=true;
            end;
      #13 : if copy(dateien.name[akut_pos],1,1)=' ' then
              begin
              ende:=true;
              delete(dateien.name[akut_pos],1,1);
              suche_ersetze(pfad,' ','');
              gross(pfad);
              dateiwahl:=pfad+'\'+dateien.name[akut_pos];
              end
            else
              begin
              delete(dateien.name[akut_pos],1,1);
              if dateien.name[akut_pos][1]<>'.' then
                pfad:=pfad+'\'+dateien.name[akut_pos]
              else
                kurze(pfad);
              suche_ersetze(pfad,' ','');
              gross(pfad);
              neue_dateien:=true;
              end;
      #27 : ende:=true;
     end;
  end;
  fensterzu(fenster);
end;

procedure get_menu(m:t_menu;var titel,befehl:byte);
var anzahl_titel  : byte;
    anzahl_befehl : array[0..9] of byte;
    lange_befehl  : array[0..9] of byte;
    pos_titel     : array[0..9] of byte;
    x,y:integer;
    ch:char;
    f:t_fenster;
    in_menu:boolean;
    s:string;
label escape;
begin
  anzahl_titel:=0;
  while m.leiste[anzahl_titel].titel<>'' do inc(anzahl_titel);
  for x:= 0 to (anzahl_titel-1) do
    with m.leiste[x] do
    begin
    anzahl_befehl[x]:=0;
    lange_befehl[x]:=0;
    while befehl[anzahl_befehl[x]]<>'' do
      begin
      inc(anzahl_befehl[x]);
      if length(befehl[anzahl_befehl[x]])>lange_befehl[x] then
        lange_befehl[x]:=length(befehl[anzahl_befehl[x]]);
      end;
    end;
  x:=0;
  for y:=0 to (anzahl_titel-1) do
    begin
    pos_titel[y]:=x;
    x:=x+length(m.leiste[y].titel);
    end;
  gotoxy(1,1);
  textcolor(schwarz); textbackground(hellgrau);
  for x:= 0 to (anzahl_titel-1) do
    for y:=0 to anzahl_befehl[x]-1 do
      begin
      s:=m.leiste[x].befehl[y];
      s:=s+copy('              ',1,lange_befehl[x]-length(s));
      m.leiste[x].befehl[y]:=s;
      end;
  for x:= 0 to anzahl_titel do
  begin
    gotoxy(pos_titel[x]+1,1);
    write (m.leiste[x].titel);
  end;
  x:=titel;
escape:
  repeat
    if x<0 then x:=anzahl_titel-1;
    if x=anzahl_titel then x:=0;
    textcolor(weiss);textbackground(schwarz);
    gotoxy(pos_titel[x]+1,1);
    write (m.leiste[x].titel);
    ch:=readkey;
    if ch=#0 then ch:=readkey;
    textcolor(schwarz);textbackground(hellgrau);
    gotoxy(pos_titel[x]+1,1);
    write (m.leiste[x].titel);
    case ch of
     #75 : dec(x);
     #77 : inc(x);
     #09 : inc(x);
    end;
  until ch=#13;
  if anzahl_befehl[x]>1 then
    begin
      repeat
        textcolor(weiss);textbackground(schwarz);
        gotoxy(pos_titel[x]+1,1);
        write (m.leiste[x].titel);
        f.x1:=pos_titel[x];
        f.y1:=1;
        f.x2:=pos_titel[x]+lange_befehl[x]+1;
        f.y2:=anzahl_befehl[x]+2;
        f.v_farbe:=weiss;
        f.h_farbe:=hellgrau;
        f.dicke:=1;
        f.shadow:=true;
        fensterauf(f);
        textcolor(schwarz);textbackground(hellgrau);
        if x=2 then textcolor(dunkelgrau);
        for y:=0 to anzahl_befehl[x] do
          begin
          gotoxy(pos_titel[x]+2,y+3);
          write(m.leiste[x].befehl[y]);
          end;
        y:=0;
        repeat
          textcolor(weiss);textbackground(schwarz);
          gotoxy(pos_titel[x]+2,y+3);
          write (m.leiste[x].befehl[y]);
          ch:=readkey;
          if ch=#0 then ch:=readkey;
          textcolor(schwarz);textbackground(hellgrau);
          if x=2 then textcolor(dunkelgrau);
          gotoxy(pos_titel[x]+2,y+3);
          write (m.leiste[x].befehl[y]);
          case ch of
            #72 : dec(y);
            #80 : inc(y);
          end;
          if y<0 then y:=anzahl_befehl[x]-1;
          if y=anzahl_befehl[x] then y:=0;
        until (ch=#13)or(ch=#77)or(ch=#75)or(ch=#27);
        fensterzu(f);
        textcolor(schwarz);textbackground(hellgrau);
        gotoxy(pos_titel[x]+1,1);
        write (m.leiste[x].titel);
        case ch of
          #77 : inc(x);
          #75 : dec(x);
          #27 : goto escape;
        end;
        if x<0 then x:=anzahl_titel-1;
        if x=anzahl_titel then x:=0;
        if anzahl_befehl[x]<2 then goto escape;
      until ch=#13;
      titel:=x;
      befehl:=y;
    end
  else
    begin
    titel:=x;
    befehl:=0;
    end;
end;

procedure del_menu(var m:t_menu);
var x,y:byte;
begin
with m do
  begin
  last_titel:=0;
  for x:=0 to 9 do
    with leiste[x] do
      begin
      titel:='';
      for y:=0 to 9 do befehl[y]:=''
      end;
  end;
end;

function  select_box(titel,t1,t2,t3,t4,t5:t_menu_string):byte;
var anzahl,x : shortint;
    s : array[1..5] of t_menu_string;
    hohe,breite,offset:byte;
    f:t_fenster;
    ch:char;
begin
  anzahl:=0;
  if t1<>'' then begin s[1]:=t1;inc(anzahl);end;
  if t2<>'' then begin s[2]:=t2;inc(anzahl);end;
  if t3<>'' then begin s[3]:=t3;inc(anzahl);end;
  if t4<>'' then begin s[4]:=t4;inc(anzahl);end;
  if t5<>'' then begin s[5]:=t5;inc(anzahl);end;
  breite:=0;
  for x:=1 to anzahl do
    if length(s[x])>breite then breite:=length(s[x]);
  if length(titel)>breite then breite:=length(titel);
  f.y1:=12-(anzahl div 2)-3;
  f.y2:=f.y1+5+anzahl;
  f.x1:=40-(breite+6) div 2;
  f.x2:=f.x1+breite+6;
  f.v_farbe:=weiss;
  f.h_farbe:=hellgrau;
  f.dicke:=1;
  f.shadow:=true;
  fensterauf(f);
  textcolor(weiss);textbackground(hellgrau);
  gotoxy(f.x1+4,f.y1+3);write(titel);
  textcolor(schwarz);
  for x:=1 to anzahl do
    begin
    s[x]:=copy('         ',1,(breite-length(s[x]))div 2)+s[x];
    s[x]:=s[x]+copy('         ',1,breite-length(s[x]));
    gotoxy(f.x1+4,f.y1+4+x);
    write(s[x]);
    end;
  x:=1;
  repeat
    textbackground(turkis);
    gotoxy(f.x1+4,f.y1+4+x);
    write(s[x]);
    ch:=readkey;
    if ch=#0 then ch:=readkey;
    textbackground(hellgrau);
    gotoxy(f.x1+4,f.y1+4+x);
    write(s[x]);
    case ch of
      #72 : dec(x);
      #80 : inc(x);
    end;
    if x=0 then x:=anzahl;
    if x>anzahl then x:=1;
  until (ch=#13)or(ch=#27);
  if ch=#13 then select_box:=x else select_box:=0;
  fensterzu(f);
end;

end.
