unit vec_3dg;
{ Ŀ
  VEC_D3G stellt die Routinen fr die rumliche Darstellung zur 
  verfgung.                                                    
  }
interface
uses vec_typs,graph,dos,vec_math,crt;

var grenze : array[1..6] of t_ebene; {6 Ebenen der Breichsgrenzen}
    obj : t_g_objekt;                {das 3D-Grafikobjekt}
    p   : array[1..512] of t_position; {die 2D Punkte}

procedure x_Plot (x,y:word;f:byte);
procedure rot_z(w:real);
procedure rot_x(w:real);
procedure rot_y(w:real);
procedure create_obj;
procedure check_obj;
procedure init_show;
procedure show_g_obj(xw,yw,zw:real);
procedure z_sort;
procedure EgaVga_Driver;
procedure printxy(text:string; zeile,spalte,text_color:byte);
procedure init_grafik;

Implementation

procedure init_grafik;
{ Ŀ
  Testet auf VGA und stellt Grafikmodus ein                     
  }
var graphdriver:integer;
begin
  if RegisterBGIdriver(@EGAVGA_Driver) < 0 then
    begin
    writeln('Bentige VGA oder EGA !');
    halt(255);
    end;
  writeln('VGA Mode ... OK');
  delay(250);
  detectgraph(graphdriver,graphmode);
  initgraph(graphdriver,graphmode,'');
end;

procedure EgaVga_Driver; external;
{ Ŀ
  Die externe EGAVGA.BGI Datei als OBJ eingebunden              
  }
{$L EGAVGA.OBJ }

procedure printxy(text:string; zeile,spalte,text_color:byte);
{ Ŀ
  Schreibt unabhngig vom Bildschirmmodus einen Text bei        
  Zeile,Spalte mit Farbe TEXT_COLOR.                            
  }
var regs:registers;
begin
  regs.ax:=$1301;         {Stringfunktion}
  regs.bl:=text_color;    {Textfarbe}
  regs.cx:=length(text);  {Lnge des Textes}
  regs.dh:=zeile;         {Ausgabezeile}
  regs.dl:=spalte;        {Ausgabespalte}
  regs.bh:=0;
  regs.es:=seg(text);     {Adresse im Speicher}
  regs.bp:=ofs(text)+1;   {berspringe TP Lngen-Byte}
  intr($10,regs);         {Video INT}
end;

procedure Calc3D (x,y,z:real; var px,py:word);
{ Ŀ
  Berechnet aus X,Y,Z die 2D-Position PX,PY fr die rumliche   
  Darstellung.                                                  
  }
var z1:real;
begin
  z1 := 400/(z+3);        {Verzerrung durch die Tiefe}
  px := 319+trunc(x*z1);  {Bezogen auf den X-Wert}
  py := 200-trunc(y*z1);  {Und Y-Wert}
end;

procedure x_Plot (x,y:word;f:byte);
{ Ŀ
  Zeichnet ein X bei X,Y mit Farbe F.                           
  }
begin
  setcolor(f);           {setze Zeichenfarbe}
  line(x-2,y-2,x+2,y+2); {Linie von links oben nach rechts unten}
  line(x-2,y+2,x+2,y-2); {Linie von links unten nach rechts oben}
end;


procedure o_plot(i:byte);
{ Ŀ
  Zeichnet eine Kugel des Objektes mit Nummer i.                
  }
var g_radius:integer;
begin
  with obj.kugel[i] do begin                     {mit Kugel mache}
    setcolor(farbe);                             {Setze Zeichenfarbe}
    g_radius:=trunc(radius/(obj.r_vector[m].z+3)); {Radius in der Tiefe}
    circle(p[m].x,p[m].y,g_radius);              {Zeichne Kugel}
    putpixel(p[m].x,p[m].y,farbe);               {Zeichne Mittelpunkt}
  end;
end;


procedure rot_z(w:real);
{ Ŀ
  Lsst alle Punkte des Objektes um die Z-Achse um w Bogenma   
  rotieren.                                                     
  }
var a,s,c:real;
    i:word;
begin
  s:=sin(w);
  c:=cos(w);
  for i:=1 to obj.v_anzahl do
    with obj.r_vector[i] do
    begin
    a:=x;
    x:=a*c-y*s;
    y:=a*s+y*c;
    end;
end;

procedure rot_x(w:real);
{ Ŀ
  Lsst alle Punkte des Objektes um die X-Achse um w Bogenma   
  rotieren.                                                     
  }
var a,s,c:real;
    i:word;
begin
  s:=sin(w);
  c:=cos(w);
  for i:=1 to obj.v_anzahl do
    with obj.r_vector[i] do
    begin
    a:=z;
    z:=a*c-y*s;
    y:=a*s+y*c;
    end;
end;

procedure rot_y(w:real);
{ Ŀ
  Lsst alle Punkte des Objektes um die Y-Achse um w Bogenma   
  rotieren.                                                     
  }
var s,c,a:real;
    i:word;
begin
  s:=sin(w);
  c:=cos(w);
  for i:=1 to obj.v_anzahl do
    with obj.r_vector[i] do
    begin
    a:=x;
    x:=a*c-z*s;
    z:=a*s+z*c;
    end;
end;

function get_free_vector:word;
{ Ŀ
  Liefert die Nummer des nchsten freien Vektors im Grafik-     
  objekt. Wenn keiner mehr frei, dann Null.                     
  }
var v:word;
begin
  v:=1;                                  {Startwert=1}
  while not(obj.frei[v]) and (v<=513) do {Solange nicht frei und kleiner 513}
  inc(v);                                {Erhhe Zhler}
  if v<>513 then                         {Zhler ungleich 513}
    get_free_vector:=v                   {Freier Vektor = Zhler}
  else                                   {sonst...}
    get_free_vector:=0;                  {Kein freier Vektor mehr}
end;

function get_free_kugel:word;
{ Ŀ
  Liefert die Nummer der nchsten freien Kugel im Grafik-       
  objekt. Wenn keine mehr frei, dann Null.                      
  }
var v:word;
begin {dito get_free_vector}
v:=1;
while (obj.kugel[v].m<>0) and (v<=128) do
  inc(v);
if v<>129 then get_free_kugel:=v else get_free_kugel:=0;
end;

function get_free_point:word;
{ Ŀ
  Liefert die Nummer des nchsten freien Punktes im Grafik-     
  objekt. Wenn keiner mehr frei, dann Null.                     
  }
var v:word;
begin {dito get_free_vector}
v:=1;
while (obj.punkt[v].p<>0) and (v<=128) do
  inc(v);
if v<>129 then get_free_point:=v else get_free_point:=0;
end;

function get_free_line:word;
{ Ŀ
  Liefert die Nummer der nchsten freien Linie im Garfik-       
  objekt. Wenn keine mehr frei, dann Null.                      
  }
var v:word;
begin {dito get_free_vector}
v:=1;
while ((obj.linie[v].a<>0) or (obj.linie[v].b<>0)) and (v<=513) do
  inc(v);
if v<>513 then get_free_line:=v else get_free_line:=0;
end;

procedure set_point(x,y,z:real;farbe:byte);
{ Ŀ
  Fgt eine Punkt ins Grafikobjekt ein bei X,Y,Z.               
  }
var p,v:word;
    ch:char;
    s:string;
begin
  p:=get_free_point;         {suche freien Punkt}
  v:=get_free_vector;        {suche freien Vektor}
  obj.punkt[p].p:=v;         {weise Punkt Vektor zu}
  obj.punkt[p].farbe:=farbe; {und die Farbe}
  obj.o_vector[v].x:=x;        {bertrage Koordinaten}
  obj.o_vector[v].y:=y;
  obj.o_vector[v].z:=z;
  obj.frei[v]:=false;        {Vektor ist besetzt}
  inc(obj.v_anzahl);         {erhhe Vektoranzahl}
  inc(obj.p_anzahl);         {erhhe Punktanzahl}
end;

procedure set_line(x1,y1,z1,x2,y2,z2:real;farbe:byte);
{ Ŀ
  Fgt eine Linie ins Grafikobjekt ein von X1,Y1,Z1 bis         
  X2,Y2,Z2 mit Farbe.                                           
  }
var l,p1,p2:word;
    ch:char;
    s:string;
begin {dito set_point nur mit zwei Punkten}
  l:=get_free_line;
  p1:=get_free_vector;
  obj.o_vector[p1].x:=x1;
  obj.o_vector[p1].y:=y1;
  obj.o_vector[p1].z:=z1;
  obj.frei[p1]:=false;
  inc(obj.v_anzahl);
  p2:=get_free_vector;
  obj.o_vector[p2].x:=x2;
  obj.o_vector[p2].y:=y2;
  obj.o_vector[p2].z:=z2;
  obj.frei[p2]:=false;
  inc(obj.v_anzahl);
  obj.linie[l].a:=p1;
  obj.linie[l].b:=p2;
  obj.linie[l].farbe:=farbe;
  inc(obj.l_anzahl);
end;

procedure real2scala(var x,y,z:real);
{ Ŀ
  REAL2SCALA wandelt die Koordinaten des Vektorraums in         
  Koordinaten des Grafikraums um.                               
  }
begin
  x:=x/setup.bereich;
  y:=y/setup.bereich;
  z:=z/setup.bereich;
end;

procedure create_grenzen;
{ Ŀ
  Erzeugt die 6 Grenzebenen des Grafikraums.                    
  }
var n:real;
begin
  fillchar(grenze,sizeof(grenze),0);     {lsche alle Grenzen}
  n:=setup.bereich;                      {spare Tipparbeit}
  with grenze[1] do begin                {erschaffe 6 Grenzebenen...}
    ansatz.x:=n;ansatz.y:=n;ansatz.z:=n;
    richtung1.x:=1;richtung2.z:=1; end;
  with grenze[2] do begin
    ansatz.x:=n;ansatz.y:=n;ansatz.z:=n;
    richtung1.y:=1;richtung2.z:=1; end;
  with grenze[3] do begin
    ansatz.x:=-n;ansatz.y:=-n;ansatz.z:=-n;
    richtung1.x:=1;richtung2.z:=1; end;
  with grenze[4] do begin
    ansatz.x:=-n;ansatz.y:=-n;ansatz.z:=-n;
    richtung1.y:=1;richtung2.z:=1; end;
  with grenze[5] do begin
    ansatz.x:=-n;ansatz.y:=-n;ansatz.z:=-n;
    richtung1.x:=1;richtung2.y:=1; end;
  with grenze[6] do begin
    ansatz.x:=n;ansatz.y:=n;ansatz.z:=n;
    richtung1.x:=1;richtung2.y:=1; end;
end;

procedure add_point(v:t_vector;farbe:byte);
{ Ŀ
  bersetze eine Punkt vom Vektorraum in den Grafikraum.        
  }

begin
  if inraum(v) then         {ist der Punkt im sichtbaren Bereich}
    with v do
    begin
    real2scala(x,y,z);      {verwandle Koordinaten}
    set_point(x,y,z,farbe); {fge ihn hinzu}
    end;
end;

procedure add_line(g:t_gerade;farbe:byte);
{ Ŀ
  bersetze eine Linie vom Vektorraum in den Grafikraum.        
  }
var v : t_vector;
    sp : array[1..6] of t_vector;
    sp1,sp2:t_vector;
    a,b:word;
begin
  fillchar(sp,sizeof(sp),0);             {lscht die Schnittpunkte}
  for a:=1 to 6 do                       {holt die Schnittpunkte mit Grenzen}
    if schnitt_g_e(g,grenze[a],v)=1 then
      if inraum(v) then                  {wenn SP im sichtbaren Bereich}
        sp[a]:=v;                        {nimm als gltigen SP auf}
  for a:=1 to 5 do
    for b:= a+1 to 6 do
      if gleich(sp[b],sp[a]) then sp[b]:=null; {lsche alle gleiche Punkte}
  b:=0;
  for a:=1 to 6 do
    if not gleich(sp[a],null) then inc(b);     {zhle Schnittpunkte}
  if b=2 then begin                            {es mssten jetzt 2 sein}
    b:=1; while gleich(sp[b],null) do inc(b);  {suche ersten SP}
    sp1:=sp[b];inc(b);
    while gleich(sp[b],null) do inc(b);  {suche zweiten SP}
    sp2:=sp[b];
    with sp1 do real2scala(x,y,z);       {verwandle Koordinaten der SPs}
    with sp2 do real2scala(x,y,z);
    set_line(sp1.x,sp1.y,sp1.z,sp2.x,sp2.y,sp2.z,farbe); {setze Linie}
  end
end;

procedure grid_ebene(e:t_ebene;farbe:byte);
{ Ŀ
  GRID_EBENE fgt Linien ein, die die Ebene E wie ein Netz      
  berziehen mit einer bestimmten Farbe.                        
  }
var r1,r2,p:t_vector;
    n:t_normalform;
    g:t_gerade;
    i:integer;
    r,faktor:real;
begin
  faktor:=setup.bereich/grid; {Faktor ist der Abstand zwischen den Geraden}
  e_2_n(e,n); {N ist Normalform  von Ebene E}
  g.ansatz:=null;                {Baue Hilfsgerade auf durch Null}
  g.richtung:=n.n_vector;        {und senkrecht zur Ebene}
  if schnitt_g_e(g,e,p)=1 then   {P ist ein Punkt der ziemlich in der Mitte}
  begin                          {der Ebene in den Bereichsgrenzen liegt}
    g.richtung:=e.richtung2;
    for i:=-grid to grid do begin {Erzeuge horizontale Linien}
      v_mul_n(e.richtung1,i*faktor,r1);
      v1_add_v2(r1,p,g.ansatz);
      add_line(g,farbe);
    end;
    g.richtung:=e.richtung1;
    for i:= -grid to grid do begin {Erzeuge vertikale Linien}
      v_mul_n(e.richtung2,i*faktor,r2);
      v1_add_v2(r2,p,g.ansatz);
      add_line(g,farbe);
    end;
  end;
end;

procedure add_ebene(e:t_ebene;farbe:byte;grid:boolean);
{ Ŀ
  bersetze eine Ebene vom Vektorraum in den Grafikraum.        
  }
var g : t_gerade;
    a : byte;
begin
  for a:=1 to 6 do                       {mit allen 6 Grenzebenen mach...}
    if schnitt_e_e(e,grenze[a],g)=1 then {hole Schnittlinien mit Grenze}
      add_line(g,farbe);                 {fge Schnittlinie hinzu}
  if grid then grid_ebene(e,farbe);
end;

procedure add_kugel(k:t_kugel;farbe:byte);
{ Ŀ
  bersetze eine Kugel vom Vektorraum in den Grafikraum.        
  }
var p,v:word;
begin
  if inraum(k.mitte) then {Kugel im Raum?}
    with k.mitte do begin
      real2scala(x,y,z);                   {verwandle Koordianten}
      v:=get_free_vector;                  {hole freien Vektor}
      p:=get_free_kugel;                   {hole freie Kugel}
      obj.kugel[p].m:=v;                   {bertrage Werte}
      obj.kugel[p].farbe:=farbe;
      obj.o_vector[v].x:=x;
      obj.o_vector[v].y:=y;
      obj.o_vector[v].z:=z;
      obj.frei[v]:=false;                  {Vektor ist jetzt besetzt}
      obj.kugel[p].radius:=400*k.radius/setup.bereich; {bereche Grafikradius}
      inc(obj.v_anzahl);                   {erhhe Vektoranzahl}
      inc(obj.k_anzahl);                   {erhhe Kugelanzahl}
    end;
end;

procedure create_obj;
{ Ŀ
  Erzeugt das Grafikobjekt aus dem Vektorraum.                  
  }
var h:real;
    z:word;
    obj_farbe : byte;
begin
  fillchar(obj,sizeof(obj),0);  {Lsche Grafikobjekt}
  create_grenzen;               {erstelle Grenzebenen}
  with obj do for z:=1 to 512 do frei[z]:=true; {gib alle Vektoren Frei}
  with setup do
  if kreuz then begin {zeiche Koordinatenkreuz}
    set_line(-1,0,0,1,0,0,farben2[1]);
    set_line(0,-1,0,0,1,0,farben2[1]);
    set_line(0,0,-1,0,0,1,farben2[1]);
    set_line(0.9,-0.05,0,1,-0.15,0,farben2[1]);
    set_line(0.9,-0.15,0,1,-0.05,0,farben2[1]);
    set_line(0.05,1,0,0.1,0.95,0,farben2[1]);
    set_line(0.05,0.9,0,0.15,1,0,farben2[1]);
    set_line(0,0.15,0.9,0,0.15,1,farben2[1]);
    set_line(0,0.15,1,0,0.05,0.9,farben2[1]);
    set_line(0,0.05,0.9,0,0.05,1,farben2[1]);
    h:=1/setup.bereich; {Lnge einer Einheit}
    set_line(h,0.05,0,h,-0.05,0,farben2[1]);
    set_line(h,0,0.05,h,0,-0.05,farben2[1]);
  end;
  if setup.box then                             {wenn Bereichsbox...}
    for z:=1 to 4 do
      add_ebene(grenze[z],farben2[2],false);    {fge Grenzen hinzu}
  for z:=1 to 8 do                              {test alle 8 Objekte}
    begin
    case setup.farbmodus of
      1 : obj_farbe:=farben1[z];                {individuell}
      2 : obj_farbe:=farben2[objekte[z].obj+2]; {je nach art}
      3 : obj_farbe:=white;                     {s/w}
    end;
    case objekte[z].obj of                      {fge Objekt hinzu}
      1 : add_point(punkte[z],obj_farbe);
      2 : add_line(geraden[z],obj_farbe);
      3 : add_ebene(ebenen[z],obj_farbe,setup.grid);
      4 : add_kugel(kugeln[z],obj_farbe);
    end;
    end;
end;

procedure check_obj;
var a,b,v,i,j:word;
{ Ŀ
  Checkt und optimiert das Grafikobjekt.                        
  }
procedure swap_point(v1,v2:word);
var xh,yh,zh:real;
    fh:boolean;
    v:word;
begin
with obj do
  begin
  fh:=frei[v1];
  xh:=o_vector[v1].x;           {lege v1 auf hilf}
  yh:=o_vector[v1].y;
  zh:=o_vector[v1].z;
  frei[v1]:=frei[v2]; 
  o_vector[v1].x:=o_vector[v2].x; {lege v2 auf v1}
  o_vector[v1].y:=o_vector[v2].y;
  o_vector[v1].z:=o_vector[v2].z;
  frei[v2]:=fh;
  o_vector[v2].x:=xh;           {lege hilf auf v2}
  o_vector[v2].y:=yh;
  o_vector[v2].z:=zh;
  for v:=1 to 512 do          {tausche Linienpunkte in Objekten, wenn ntig}
    begin
    if linie[v].a=v1 then linie[v].a:=v2
    else
      if linie[v].a=v2 then linie[v].a:=v1;
    if linie[v].b=v1 then linie[v].b:=v2
    else
      if linie[v].b=v2 then linie[v].b:=v1;
    end;
  for v:=1 to 128 do          {tausche Punkte in Objekten, wenn ntig}
    begin
    if punkt[v].p=v1 then punkt[v].p:=v2
    else
      if punkt[v].p=v2 then punkt[v].p:=v1;
    if kugel[v].m=v1 then kugel[v].m:=v2
    else
      if kugel[v].m=v2 then kugel[v].m:=v1;
    end;
  end;
end;

begin
with obj do
  begin
  for a:=1 to v_anzahl-1 do        {gehe alle Punkte durch}
    for b:= a+1 to v_anzahl do     {und vergleiche sie mit dem Rest}
      if gleich(o_vector[a],o_vector[b]) then
        begin                                {losche doppelte punkt}
        for i:=1 to p_anzahl do
          if punkt[i].p=b then punkt[i].p:=a;
        for i:=1 to l_anzahl do begin
          if linie[i].a=b then linie[i].a:=a;
          if linie[i].b=b then linie[i].b:=a;
        end;
        for i:=1 to k_anzahl do
          if kugel[i].m=b then kugel[i].m:=a;
        frei[b]:=true;
        end;
  v_anzahl:=0;
  for v:=1 to 512 do {zhle die verbleibenden Vektoren}
      if not frei[v] then inc(v_anzahl);
  while get_free_vector<=v_anzahl do  {optimire punkte}
    begin {lsche Lcher in der Vektorenliste}
    for i:=(v_anzahl+1) to 512 do
      if not frei[i] then v:=i;
    swap_point(get_free_vector,v);
    end;
  end;
end;

procedure init_show;
{ Ŀ
  Bereitet die Grafik des Vektorraums vor.                      
  }
var t : string;
begin
  setgraphmode(graphmode);        {Grafikmodus}
  cleardevice;                    {lsche Bildschirm}
  setcolor(white);                {Zeichenfarbe weiss}
  rectangle(0,0,639,479);         {zeichne Umrandungsboxen}
  rectangle(0,400,639,479);
  setfillstyle(1,0);              {def. Fllart}
  setviewport(1,1,638,399,true);  {def. Sichtfenster}
  setlinestyle(0,255,1);          {def. Linienart}
  printxy('VEKTOR 2.0 (C)',26,42,15);
  printxy('P',26,57,red);
  printxy('R',26,58,lightred);
  printxy('I',26,59,yellow);
  printxy('S',26,60,green);
  printxy('M',26,61,lightblue);
  printxy('A',26,62,magenta);
  printxy('Software',26,64,white);

  printxy('MAUS   - Rotiere Grafikobjekt',26,2,7);
  printxy('RETURN - Erstelle Standbild',27,2,7);
  printxy('ESC    - Zurck ins Men                     Projekt: '+setup.obj_name,28,2,7);
end;

procedure show_g_obj(xw,yw,zw:real);
{ Ŀ
  Zeigt das Grafikobjekt auf dem Bildschirm.                    
  }
var  i : word;
begin
  setcolor(black);
  move(obj.o_vector,obj.r_vector,sizeof(obj.o_vector));
  rot_y(yw);
  rot_x(xw);
  {rot_z(zw);}
  with obj do
   begin
   for i:=1 to v_anzahl do {rechnet neue Positionen aus}
     calc3d(r_vector[i].x,r_vector[i].y,r_vector[i].z,p[i].x,p[i].y);
   bar(0,0,638,398); {lsche Sichtfenster}
   for i:=1 to l_anzahl do {setzt Linien}
     with linie[i] do
     begin
     setcolor(farbe);
     line(p[a].x,p[a].y,p[b].x,p[b].y);
     end;
   for i:=1 to k_anzahl do
     o_plot(i); {setzt Kugeln}
   for i:=1 to p_anzahl do
     x_plot(p[punkt[i].p].x,p[punkt[i].p].y,punkt[i].farbe); {setzt Punkte}
   end;
end;

procedure z_sort;
{ Ŀ
  Sortiert die Linien im Grafikobjekt nach rumlicher Tiefe.    
  }
type t_feld = record
       z_wert: real;
       nr    : word;
     end;

var feld : array[1..512] of t_feld;
    c:word;
    o:t_g_objekt;

procedure min_sort(n:integer);
  var grenze,position,zahler:integer;
      wert : t_feld;
  begin {einfacher MIN-SORTER}
  for grenze:=1 to pred(n) do
    begin
    wert:=feld[grenze];
    position:=grenze;
    for zahler := grenze to n do
      if feld[zahler].z_wert>wert.z_wert then
        begin
        wert:=feld[zahler];
        position:=zahler;
        end;
    feld[position]:=feld[grenze];
    feld[grenze]:=wert;
  end;
end;

begin
  for c:=1 to obj.l_anzahl do {mit allen Linien mache..}
    begin
    {berechne mittlere Tiefe}
    feld[c].z_wert:=(obj.o_vector[obj.linie[c].a].z+obj.o_vector[obj.linie[c].b].z)/2;
    feld[c].nr:=c; {merke Linien Nummer}
    end;
  min_sort(obj.l_anzahl); {sortiere Linien nach rumlicher Tiefe}
  o:=obj;
  for c:=obj.l_anzahl downto 1 do {bertrage Sortierung aufs Grafikobjekt}
    obj.linie[c]:=o.linie[feld[c].nr]; 
end;

begin
  init_grafik; {Test auf VGA}
end.