unit vec_mask;
{ Ŀ
  VEC_MASK stellt die Eingabemasken in der Menuoberflche       
  }
interface
uses menufx,vec_typs,vec_math,crt,dos;

procedure status_line(text:string);
procedure info_box;
procedure share_box;
procedure show_obj_name;
procedure show_vec(v:t_vector);
procedure show_obj(nr:byte;invers:boolean);
procedure show_all_obj;
function  select_obj:byte;
function  obj_frei:byte;
procedure del_vec_raum;
procedure loschen;
procedure einfugen;
procedure verandern;
procedure eingabe_bereich;
function  eingabe_punkt(var v:t_vector;vorgabe:boolean):boolean;
function  eingabe_gerade(var g:t_gerade;vorgabe:boolean):boolean;
function  zwei_punkte(var g:t_gerade):boolean;
function  eingabe_normal(var e:t_ebene):boolean;
function  eingabe_ko_form(var e:t_ebene):boolean;
function  eingabe_ebene(var e:t_ebene;vorgabe:boolean):boolean;
function  eingabe_kugel(var k:t_kugel;vorgabe:boolean):boolean;

Implementation

procedure status_line(text:string);
{ Ŀ
  STATUS_LINE gibt TEXT auf der untersten Zeile aus.            
  }
var a:string;
begin
  fillchar(a,255,255); {flle mit Leerzeichen}
  a:=' '+text;         {setze eigentlichen Text}
  a[0]:=#79;           {Setze feste Lange, so wird altes berschrieben}
  gotoxy(1,25);        {gehe in unterste Zeile}
  textcolor(schwarz);textbackground(hellgrau);
  write(a);            {schreibe string}
end;

function obj_frei:byte;
{ Ŀ
  OBJ_FREI liefert die Nummer des nchst freien Objektes, sonst 
  die Null,wenn kein Objekt mehr frei ist.                      
  }
var x:byte;
begin
  x:=0;
  repeat
    inc(x);
  until (x=9)or(objekte[x].obj=0); {Prfe alle Objekte}
  if x<9 then
    obj_frei:=x                    {Suche war erfolgreich}
  else
    obj_frei:=0;                   {oder auch nicht}
end;

procedure del_vec_raum;
{ Ŀ
  DEL_VEC_RAUM lscht den Vektorraum und setzt das Standardsetup
  }
var x:byte;
begin
  fillchar(objekte,sizeof(objekte),0); {setze alles auf 0}
  with setup do begin {setzte Standardwerte}
    obj_name:='KEINNAME.VEK';
    farbmodus:=2;
    box:=true;
    kreuz:=true;
    grid:=false;
    bereich:=10;
    z_buff:=true;
  end;
end;

procedure show_obj_name;
{ Ŀ
  SHOW_OBJ_NAME zeigt den Namen des Projekts am Fensterrand.    
  }
begin
  gross(setup.obj_name); {Grossbuchstaben}
  gotoxy(34,2);          {gehe zum Fensterrand}
  textcolor(weiss);      {setzte Farbe}
  textbackground(blau);
  write(' '+setup.obj_name+' '); {berschreibe Rest mit Balken}
end;

procedure info_box;
{ Ŀ
  INFO_BOX ffnet ein Fenster mit Informationen ber VEKTOR     
  }
var f:t_fenster;
begin
  status_line('VEKTOR 2.0 (C) 1996 PRISMA Software           Unregistrierte Shareware-Version');
  with f do begin {deklariere Fenster}
    x1:=20;
    y1:=6;
    x2:=x1+39;
    y2:=y1+12;
    v_farbe:=weiss;
    h_farbe:=hellgrau;
    dicke:=2;
    shadow:=true;
  end;
  fensterauf(f);
  textcolor(weiss);textbackground(hellgrau);
  gotoxy(f.x1+7,f.y1+3);write('    V E K T O R ');
  gotoxy(f.x1+7,f.y1+5);write('  Analytische Geometrie ');
  gotoxy(f.x1+7,f.y1+7);write('  Schnitt,Abstand,Winkel');
  gotoxy(f.x1+7,f.y1+9);write('  Rumliche Darstellung ');
  textcolor(red);
  gotoxy(f.x1+3,f.y1+11);write('  Unregistrierte Shareware-Version ');

  waitkey;
  fensterzu(f);
end;

procedure share_box;
{ Ŀ
  Share_BOX ffnet ein Fenster mit Informationen ber VEKTOR    
  }
var f:t_fenster;
begin
  status_line('VEKTOR 2.0 (C) 1996 PRISMA Software           Unregistrierte Shareware-Version');
  with f do begin {deklariere Fenster}
    x1:=10;
    y1:=4;
    x2:=x1+59;
    y2:=y1+15;
    v_farbe:=weiss;
    h_farbe:=hellgrau;
    dicke:=2;
    shadow:=true;
  end;
  fensterauf(f);
  textcolor(weiss);textbackground(hellgrau);
  gotoxy(f.x1+3,f.y1+3);write('                V E K T O R ');
  gotoxy(f.x1+3,f.y1+5); write('Dies ist eine unregistrierte Shareware-Version. Um auch ');
  gotoxy(f.x1+3,f.y1+6); write('die restlichen Funktionen zu nutzen, lassen Sie sich ');
  gotoxy(f.x1+3,f.y1+7); write('bitte als lizenzierten Anwender registrieren :');
  gotoxy(f.x1+3,f.y1+9); write('        DM 40,00 Vollversion ');
  gotoxy(f.x1+3,f.y1+10);write('        DM 20,00 fr Schler und Studenten ');
  gotoxy(f.x1+3,f.y1+11);write('        DM 100,00 Turbo Pascal Quelltext ');
  gotoxy(f.x1+3,f.y1+13);write('Adresse : Martin Otten, Jgerstr. 216, 46149 Oberhausen');
  gotoxy(f.x1+3,f.y1+14);write('          motten00@marvin.informatik.uni-dortmund.de ');
  waitkey;
  fensterzu(f);
end;

procedure show_vec(v:t_vector);
{ Ŀ
  SHOW_VEC zeigt einen Vektor an der aktuellen Cursorposition   
  }
var x,y:integer;
begin
  x:=wherex; {Hole Cursorposition}
  y:=wherey;
  gotoxy(x,y-2);write('      ');
  gotoxy(x,y-1);write(''+rstring(v.x)+'');
  gotoxy(x,y+0);write(''+rstring(v.y)+'');
  gotoxy(x,y+1);write(''+rstring(v.z)+'');
  gotoxy(x,y+2);write('      ');
  gotoxy(x+8,y); {setzte Cursor hinter Vektor}
end;

procedure show_obj(nr:byte;invers:boolean);
{ Ŀ
  SHOW_OBJ zeigt Objekt NR an seiner Position normal oder invers
  }
var x,y:byte;
begin
  x:=2+40*((nr-1) div 4); {berechne Position des Objektes}
  y:=2+5*((nr-1) mod 4);
  block(x,y,x+36,y+4,32,gelb,blau);
  if invers then
    begin
    textcolor(blau);
    block(x,y,x+36,y+4,32,blau,hellgrau); {Zeichne Inversblock}
    textbackground(hellgrau);             {Setze Inversfarbe}
    end
  else
    begin
    if setup.farbmodus=1 then              {zeichne Normal}
      textcolor(farben1[nr])               {achte auf Farbmodus}
    else
      textcolor(gelb);                     {alle Objekte Gelb}
    block(x,y,x+36,y+4,32,gelb,blau);      {lsche Hintergrund}
    textbackground(blau);                  {Hintergrundfarbe blau}
    end;
  with objekte[nr] do                      {zeige Objekte}
  case obj of
   1 : begin                               {Punkt}
       gotoxy(x+1,y+3);
       write('P : x=');
       show_vec(punkte[nr]);
       end;
   2 : begin                               {Gerade}
       gotoxy(x+1,y+3);
       write('G : x=');
       show_vec(geraden[nr].ansatz);
       write('+k*');
       show_vec(geraden[nr].richtung);
       end;
   3 : begin                               {Ebene}
       gotoxy(x+1,y+3);
       write('E : x=');
       show_vec(ebenen[nr].ansatz);
       write('+k*');
       show_vec(ebenen[nr].richtung1);
       write('+l*');
       show_vec(ebenen[nr].richtung2);
       end;
   4 : begin                               {Kugel}
       gotoxy(x+1,y+1);
       write('                 2');
       gotoxy(x+1,y+2);
       write('                 ');
       gotoxy(x+1,y+4);
       write('                 ');
       gotoxy(x+1,y+5);
       write('                 ');
       gotoxy(x+1,y+3);
       write('K :  x - ');
       show_vec(kugeln[nr].mitte);
       write(' - ('+rstring(kugeln[nr].radius)+')=0');
       end;
  end;
end;

procedure show_all_obj;
{ Ŀ
  SHOW_ALL_OBJ zeigt alle acht Objekte auf dem Schirm.          
  }
var x:byte;
begin
  for x:=1 to 8 do
    show_obj(x,false);  {zeige alle acht objekte}
end;

function select_obj:byte;
{ Ŀ
  SELECT_OBJ liefert die Nummer eines gewhlten Objektes.       
  }
var x:shortint;
    ch:char;
begin
  x:=1;
  repeat
    show_obj(x,true);       {zeige block}
    ch:=readkey;            {lies Taste}
    if ch=#0 then ch:=readkey; {wenn Funktionstaste lies nochmal}
    show_obj(x,false);      {lsche Block}
    case ch of
      'P' : inc(x);         {das sind die Cursortasten}
      'H' : dec(x);
      'K' : dec(x,4);
      'M' : inc(x,4);
    end;
    if x<1 then inc(x,8);   {Warparound}
    if x>8 then dec(x,8);
  until (ch=#13)or(ch=#27); {ende bei Return oder ESC}
  if ch=#13 then            {wenn Return}
    select_obj:=x           {bernimm Ergebnis}
  else
    select_obj:=0;          {sonst keins}
end;

procedure loschen;
{ Ŀ
  LOSCHEN lsst ein Objekt whlen und lscht es.                
  }
var x:byte;
begin
  status_line('Whlen Sie Objekt zum lschen');
  x:=select_obj;
  if x<>0 then
    objekte[x].obj:=0;   {lsche Objekt}
end;

function eingabe_punkt(var v:t_vector;vorgabe:boolean):boolean;
{ Ŀ
  EINGABE_PUNKT liest eine Punkt oder verndert einen Alten.    
  }
var f:t_fenster;
    s,a:string;
    c,i:integer;
    r:real;
begin
  status_line('Bitte geben Sie Koordinaten des Punktes ein');
  with f do begin {Fenster}
    x1:=26;
    y1:=7;
    x2:=x1+28;
    y2:=y1+10;
    v_farbe:=weiss;
    h_farbe:=hellgrau;
    dicke:=2;
    shadow:=true;
  end;
  fensterauf(f);
  gotoxy(f.x1+5,f.y1+3);
  textcolor(weiss);textbackground(hellgrau);
  write('Eingabe des Punktes : ');
  textcolor(schwarz);
  gotoxy(f.x1+7,f.y1+5);write('           ');  {zeichne Maske}
  gotoxy(f.x1+7,f.y1+6);write('           ');
  gotoxy(f.x1+7,f.y1+7);write('x =        ');
  gotoxy(f.x1+7,f.y1+8);write('           ');
  gotoxy(f.x1+7,f.y1+9);write('           ');
  block(f.x1+11,f.y1+5,f.x1+17,f.y1+7,32,schwarz,turkis);
  textbackground(turkis);
  if vorgabe then a:=rstring(v.x) else a:='';     {Eingabe der Werte}
  v.x:=sreal(input_string(f.x1+12,f.y1+6,6,a));
  gotoxy(f.x1+12,f.y1+6);write(v.x:6:3);
  if vorgabe then a:=rstring(v.y) else a:='';
  v.y:=sreal(input_string(f.x1+12,f.y1+7,6,a));
  gotoxy(f.x1+12,f.y1+7);write(v.y:6:3);
  if vorgabe then a:=rstring(v.z) else a:='';
  v.z:=sreal(input_string(f.x1+12,f.y1+8,6,a));
  gotoxy(f.x1+12,f.y1+8);write(v.z:6:3);
  eingabe_punkt:=true;
  waitkey;
  fensterzu(f);
end;

procedure eingabe_bereich;
var f:t_fenster;
    s,a:string;
    b:byte;
    code:integer;
begin
  status_line('Bitte geben Sie den Darstellungsbereich fr die Grafik ein');
  with f do begin
    x1:=21;
    y1:=7;
    x2:=x1+36;
    y2:=y1+4;
    v_farbe:=weiss;
    h_farbe:=hellgrau;
    dicke:=2;
    shadow:=true;
  end;
  fensterauf(f);
  gotoxy(f.x1+3,f.y1+3);
  textcolor(weiss);textbackground(hellgrau);
  write(' Grafikbereich (1..100) :');
  textcolor(schwarz);
  textbackground(turkis);
  str(setup.bereich:3:0,a);
  s:=input_string(f.x1+29,f.y1+3,3,a);
  val(s,b,code);
  if (b>100)or(b<1) or (code<>0) then     {Prfe Bereich und Code}
    warnung(' Grafikbreich nicht zulssig ')
  else
    setup.bereich:=b;
  fensterzu(f);
end;

function eingabe_gerade(var g:t_gerade;vorgabe:boolean):boolean;
{ Ŀ
  EINGABE_GERADE liest eine Gerade oder verndert eine Alte.    
  }
var f:t_fenster;
    s,a:string;
    c,i:integer;
    r:real;
begin
  eingabe_gerade:=true;
  status_line('Bitte geben Sie Gerade als Parameterform ein');
  with f do begin
    x1:=20;
    y1:=7;
    x2:=x1+40;
    y2:=y1+10;
    v_farbe:=weiss;
    h_farbe:=hellgrau;
    dicke:=2;
    shadow:=true;
  end;
  fensterauf(f);
  gotoxy(f.x1+12,f.y1+3);
  textcolor(weiss);textbackground(hellgrau);
  write('Eingabe der Geraden : ');
  textcolor(schwarz);
  gotoxy(f.x1+7,f.y1+5);write('                        ');
  gotoxy(f.x1+7,f.y1+6);write('                        ');
  gotoxy(f.x1+7,f.y1+7);write('x =        + k *        ');
  gotoxy(f.x1+7,f.y1+8);write('                        ');
  gotoxy(f.x1+7,f.y1+9);write('                        ');
  block(f.x1+11,f.y1+5,f.x1+17,f.y1+7,32,schwarz,turkis);
  block(f.x1+26,f.y1+5,f.x1+32,f.y1+7,32,schwarz,turkis);
  textbackground(turkis);
  if vorgabe then a:=rstring(g.ansatz.x) else a:='';
  g.ansatz.x:=sreal(input_string(f.x1+12,f.y1+6,6,a));
  gotoxy(f.x1+12,f.y1+6);write(g.ansatz.x:6:3);
  if vorgabe then a:=rstring(g.ansatz.y) else a:='';
  g.ansatz.y:=sreal(input_string(f.x1+12,f.y1+7,6,a));
  gotoxy(f.x1+12,f.y1+7);write(g.ansatz.y:6:3);
  if vorgabe then a:=rstring(g.ansatz.z) else a:='';
  g.ansatz.z:=sreal(input_string(f.x1+12,f.y1+8,6,a));
  gotoxy(f.x1+12,f.y1+8);write(g.ansatz.z:6:3);
  if vorgabe then a:=rstring(g.richtung.x) else a:='';
  g.richtung.x:=sreal(input_string(f.x1+27,f.y1+6,6,a));
  gotoxy(f.x1+27,f.y1+6);write(g.richtung.x:6:3);
  if vorgabe then a:=rstring(g.richtung.y) else a:='';
  g.richtung.y:=sreal(input_string(f.x1+27,f.y1+7,6,a));
  gotoxy(f.x1+27,f.y1+7);write(g.richtung.y:6:3);
  if vorgabe then a:=rstring(g.richtung.z) else a:='';
  g.richtung.z:=sreal(input_string(f.x1+27,f.y1+8,6,a));
  gotoxy(f.x1+27,f.y1+8);write(g.richtung.z:6:3);
  waitkey;
  fensterzu(f);
  if gleich(g.richtung,null) then begin
    warnung('Richtungsvektor unzulssig');
    eingabe_gerade:=false;end;
end;

function zwei_punkte(var g:t_gerade):boolean;
{ Ŀ
  ZWEI_PUNKTE lsst 2 Punkte whlen und bestimmt daraus die     
  Gerade.                                                       
  }
var obj:byte;
    p1,p2:t_vector;
begin
  zwei_punkte:=true;
  status_line('Whlen Sie Punkt 1 der Geraden');
  obj:=select_obj; {Whle punkt 1}
  if objekte[obj].obj<>1 then begin {ist gewhltes Objekt ein Punkt}
    warnung('Gewhltes Objekt ist kein Punkt');
    exit;end;
  p1:=punkte[obj];  {bernimm punkt}
  status_line('Whlen Sie Punkt 2 der Geraden');
  obj:=select_obj;
  if objekte[obj].obj<>1 then begin
    warnung('Gewhltes Objekt ist kein Punkt');
    exit;end;
  p2:=punkte[obj];
  g.ansatz:=p1;
  v1_sub_v2(p2,p1,g.richtung);
  if gleich(p1,p2) then {punkte mssen verschieden sein}
    begin
    warnung('Punkte sind identisch');
    zwei_punkte:=false;
  end;
end;

function eingabe_3_punkte(var e:t_ebene):boolean;
{ Ŀ
  EINGABE_3_PUNKTE lsst den Benutzer 3 Punkte auswhlen und    
  bestimmt daraus die Ebene.                                    
  }
var obj:byte;
    p1,p2,p3:t_vector;
begin
  eingabe_3_punkte:=true;
  status_line('Whlen Sie Punkt 1 der Ebene');
  obj:=select_obj;
  if objekte[obj].obj<>1 then begin
    warnung('Gewhltes Objekt ist kein Punkt');
    exit;end;
  p1:=punkte[obj];
  status_line('Whlen Sie Punkt 2 der Ebene');
  obj:=select_obj;
  if objekte[obj].obj<>1 then begin
    warnung('Gewhltes Objekt ist kein Punkt');
    exit;end;
  p2:=punkte[obj];
  status_line('Whlen Sie Punkt 3 der Ebene');
  obj:=select_obj;
  if objekte[obj].obj<>1 then begin
    warnung('Gewhltes Objekt ist kein Punkt');
    exit;end;
  p3:=punkte[obj];
  e.ansatz:=p1;
  v1_sub_v2(p2,p1,e.richtung1);
  v1_sub_v2(p3,p1,e.richtung2);
  if gleich(p1,p2) or gleich(p1,p3) or gleich(p2,p3) then
    begin
    warnung('Punkte sind identisch');
    eingabe_3_punkte:=false;
  end;
end;

function eingabe_kugel(var k:t_kugel;vorgabe:boolean):boolean;
{ Ŀ
  EINGABE_KUGEL liest eine Kugel oder verndert eine Alte.      
  }
var f:t_fenster;
    s,a:string;
    c,i:integer;
    r:real;
begin
  eingabe_kugel:=true;
  status_line('Bitte geben Sie Kugelparameter ein');
  with f do begin
    x1:=20;
    y1:=7;
    x2:=x1+40;
    y2:=y1+10;
    v_farbe:=weiss;
    h_farbe:=hellgrau;
    dicke:=2;
    shadow:=true;
  end;
  fensterauf(f);
  gotoxy(f.x1+12,f.y1+3);
  textcolor(weiss);textbackground(hellgrau);
  write('Eingabe der Kugel : ');
  textcolor(schwarz);
  gotoxy(f.x1+3,f.y1+5);write('                 2 ');
  gotoxy(f.x1+3,f.y1+6);write('                   ');
  gotoxy(f.x1+3,f.y1+7);write('K :  x -          -(       ) = 0');
  gotoxy(f.x1+3,f.y1+8);write('                   ');
  gotoxy(f.x1+3,f.y1+9);write('                   ');
  block(f.x1+13,f.y1+5,f.x1+19,f.y1+7,32,schwarz,turkis);
  block(f.x1+26,f.y1+6,f.x1+32,f.y1+6,32,schwarz,turkis);
  textbackground(turkis);
  if vorgabe then a:=rstring(k.mitte.x) else a:='';
  k.mitte.x:=sreal(input_string(f.x1+14,f.y1+6,6,a));
  gotoxy(f.x1+14,f.y1+6);write(k.mitte.x:6:3);
  if vorgabe then a:=rstring(k.mitte.y) else a:='';
  k.mitte.y:=sreal(input_string(f.x1+14,f.y1+7,6,a));
  gotoxy(f.x1+14,f.y1+7);write(k.mitte.y:6:3);
  if vorgabe then a:=rstring(k.mitte.z) else a:='';
  k.mitte.z:=sreal(input_string(f.x1+14,f.y1+8,6,a));
  gotoxy(f.x1+14,f.y1+8);write(k.mitte.z:6:3);
  if vorgabe then a:=rstring(k.radius) else a:='';
  k.radius:=sreal(input_string(f.x1+27,f.y1+7,6,a));
  gotoxy(f.x1+27,f.y1+7);write(k.radius:6:3);
  waitkey;
  fensterzu(f);
  if k.radius <=0 then
    begin
    eingabe_kugel:=false;
    warnung('Radius nicht zulssig');
    end;
end;

function eingabe_normal(var e:t_ebene):boolean;
{ Ŀ
  EINGABE_NORMAL liest eine Ebene in Normalenform ein.          
  }
var f:t_fenster;
    s,a:string;
    c,i:integer;
    r:real;
    n:t_normalform;
begin
  eingabe_normal:=true;
  status_line('Bitte geben Sie Ebene als Normalform ein');
  with f do begin
    x1:=18;
    y1:=7;
    x2:=x1+44;
    y2:=y1+10;
    v_farbe:=weiss;
    h_farbe:=hellgrau;
    dicke:=2;
    shadow:=true;
  end;
  fensterauf(f);
  gotoxy(f.x1+14,f.y1+3);
  textcolor(weiss);textbackground(hellgrau);
  write('Eingabe der Ebene : ');
  textcolor(schwarz);
  gotoxy(f.x1+6,f.y1+5);write('                           ');
  gotoxy(f.x1+6,f.y1+6);write('                           ');
  gotoxy(f.x1+6,f.y1+7);write('E :         *  x -          = 0');
  gotoxy(f.x1+6,f.y1+8);write('                           ');
  gotoxy(f.x1+6,f.y1+9);write('                           ');
  block(f.x1+10,f.y1+5,f.x1+16,f.y1+7,32,schwarz,turkis);
  block(f.x1+28,f.y1+5,f.x1+34,f.y1+7,32,schwarz,turkis);
  textbackground(turkis);a:='';
  n.n_vector.x:=sreal(input_string(f.x1+11,f.y1+6,6,a));
  gotoxy(f.x1+11,f.y1+6);write(n.n_vector.x:6:3);
  n.n_vector.y:=sreal(input_string(f.x1+11,f.y1+7,6,a));
  gotoxy(f.x1+11,f.y1+7);write(n.n_vector.y:6:3);
  n.n_vector.z:=sreal(input_string(f.x1+11,f.y1+8,6,a));
  gotoxy(f.x1+11,f.y1+8);write(n.n_vector.z:6:3);
  n.a_vector.x:=sreal(input_string(f.x1+29,f.y1+6,6,a));
  gotoxy(f.x1+29,f.y1+6);write(n.a_vector.x:6:3);
  n.a_vector.y:=sreal(input_string(f.x1+29,f.y1+7,6,a));
  gotoxy(f.x1+29,f.y1+7);write(n.a_vector.y:6:3);
  n.a_vector.z:=sreal(input_string(f.x1+29,f.y1+8,6,a));
  gotoxy(f.x1+29,f.y1+8);write(n.a_vector.z:6:3);
  waitkey;
  fensterzu(f);
  if gleich(n.n_vector,null) then
    begin
    eingabe_normal:=false;
    warnung('Normalenvektor nicht zulssig');
    end
  else
    n_2_e(n,e); {alles OK}
end;

function eingabe_ko_form(var e:t_ebene):boolean;
{ Ŀ
  EINGABE_KO_FORM liest eine Ebene in Koordinatenform ein.      
  }
var f:t_fenster;
    s,a:string;
    c,i:integer;
    r:real;
    n:t_normalform;
    ko:t_ko_form;
begin
  eingabe_ko_form:=true;
  status_line('Bitte geben Sie Ebene in Koordinatenform ein');
  with f do begin
    x1:=14;
    y1:=7;
    x2:=x1+50;
    y2:=y1+7;
    v_farbe:=weiss;
    h_farbe:=hellgrau;
    dicke:=2;
    shadow:=true;
  end;
  fensterauf(f);
  gotoxy(f.x1+18,f.y1+3);
  textcolor(weiss);textbackground(hellgrau);
  write('Eingabe der Ebene : ');
  textcolor(schwarz);
  gotoxy(f.x1+7,f.y1+5);write('X*       +Y*       +Z*       +       =0');
  block(f.x1+28,f.y1+4,f.x1+34,f.y1+4,32,schwarz,turkis);
  block(f.x1+36,f.y1+4,f.x1+42,f.y1+4,32,schwarz,turkis);
  block(f.x1+18,f.y1+4,f.x1+24,f.y1+4,32,schwarz,turkis);
  textbackground(turkis);a:='';
  ko.x:=sreal(input_string(f.x1+9,f.y1+5,6,a));
  gotoxy(f.x1+9,f.y1+5);write(ko.x:6:3);
  ko.y:=sreal(input_string(f.x1+19,f.y1+5,6,a));
  gotoxy(f.x1+19,f.y1+5);write(ko.y:6:3);
  ko.z:=sreal(input_string(f.x1+29,f.y1+5,6,a));
  gotoxy(f.x1+29,f.y1+5);write(ko.z:6:3);
  ko.k:=sreal(input_string(f.x1+37,f.y1+5,6,a));
  gotoxy(f.x1+37,f.y1+5);write(ko.k:6:3);
  waitkey;
  fensterzu(f);
  if (ko.x=0)and(ko.y=0)and(ko.z=0) then
    begin
    eingabe_ko_form:=false;
    warnung('Koordinatenform nicht zulssig');
    end
  else
    begin
    ko_2_n(ko,n);
    n_2_e(n,e); {alles OK}
    end;
end;

function eingabe_ebene(var e:t_ebene;vorgabe:boolean):boolean;
{ Ŀ
  EINGABE_EBENE liest eine Ebene oder verndert eine Alte.      
  }
var f:t_fenster;
    s,a:string;
    c,i:integer;
    r:real;
begin
  eingabe_ebene:=true;
  status_line('Bitte geben Sie Ebene als Parameterform ein');
  with f do begin
    x1:=13;
    y1:=7;
    x2:=x1+55;
    y2:=y1+10;
    v_farbe:=weiss;
    h_farbe:=hellgrau;
    dicke:=2;
    shadow:=true;
  end;
  fensterauf(f);
  gotoxy(f.x1+20,f.y1+3);
  textcolor(weiss);textbackground(hellgrau);
  write('Eingabe der Ebene : ');
  textcolor(schwarz);
  gotoxy(f.x1+7,f.y1+5);write('                                     ');
  gotoxy(f.x1+7,f.y1+6);write('                                     ');
  gotoxy(f.x1+7,f.y1+7);write('x =        + k *        + l *        ');
  gotoxy(f.x1+7,f.y1+8);write('                                     ');
  gotoxy(f.x1+7,f.y1+9);write('                                     ');
  block(f.x1+11,f.y1+5,f.x1+17,f.y1+7,32,schwarz,turkis);
  block(f.x1+26,f.y1+5,f.x1+32,f.y1+7,32,schwarz,turkis);
  block(f.x1+41,f.y1+5,f.x1+47,f.y1+7,32,schwarz,turkis);
  textbackground(turkis);
  if vorgabe then a:=rstring(e.ansatz.x) else a:='';
  e.ansatz.x:=sreal(input_string(f.x1+12,f.y1+6,6,a));
  gotoxy(f.x1+12,f.y1+6);write(e.ansatz.x:6:3);
  if vorgabe then a:=rstring(e.ansatz.y) else a:='';
  e.ansatz.y:=sreal(input_string(f.x1+12,f.y1+7,6,a));
  gotoxy(f.x1+12,f.y1+7);write(e.ansatz.y:6:3);
  if vorgabe then a:=rstring(e.ansatz.z) else a:='';
  e.ansatz.z:=sreal(input_string(f.x1+12,f.y1+8,6,a));
  gotoxy(f.x1+12,f.y1+8);write(e.ansatz.z:6:3);
  if vorgabe then a:=rstring(e.richtung1.x) else a:='';
  e.richtung1.x:=sreal(input_string(f.x1+27,f.y1+6,6,a));
  gotoxy(f.x1+27,f.y1+6);write(e.richtung1.x:6:3);
  if vorgabe then a:=rstring(e.richtung1.y) else a:='';
  e.richtung1.y:=sreal(input_string(f.x1+27,f.y1+7,6,a));
  gotoxy(f.x1+27,f.y1+7);write(e.richtung1.y:6:3);
  if vorgabe then a:=rstring(e.richtung1.z) else a:='';
  e.richtung1.z:=sreal(input_string(f.x1+27,f.y1+8,6,a));
  gotoxy(f.x1+27,f.y1+8);write(e.richtung1.z:6:3);
  if vorgabe then a:=rstring(e.richtung2.x) else a:='';
  e.richtung2.x:=sreal(input_string(f.x1+42,f.y1+6,6,a));
  gotoxy(f.x1+42,f.y1+6);write(e.richtung2.x:6:3);
  if vorgabe then a:=rstring(e.richtung2.y) else a:='';
  e.richtung2.y:=sreal(input_string(f.x1+42,f.y1+7,6,a));
  gotoxy(f.x1+42,f.y1+7);write(e.richtung2.y:6:3);
  if vorgabe then a:=rstring(e.richtung2.z) else a:='';
  e.richtung2.z:=sreal(input_string(f.x1+42,f.y1+8,6,a));
  gotoxy(f.x1+42,f.y1+8);write(e.richtung2.z:6:3);
  waitkey;
  fensterzu(f);
  if gleich(e.richtung1,null) or gleich(e.richtung2,null) then
    begin
    eingabe_ebene:=false;
    warnung('Richtugnsvektoren nicht zulssig');
    end;
end;

procedure einfugen;
{ Ŀ
  EINFUGEN fgt ein neues Objekt ein.                           
  }
var art,                      {Art des Objektes}
    nr,                       {Nummer des Objektes}
    gerade,ebene:byte;        {Eingabeform des Objektes bei E und G}
    ok:boolean;               {OK gibt an, ob die Eingabe korrekt war}
begin
  status_line('Whlen Sie die Art des Objekts');
  art:=select_box('Welches Objekt einfgen : ','Punkt ','Gerade','Ebene ','Kugel ','');
  nr:=obj_frei; {hole nchstes freies Objekt}
  if nr<>0 then {wenn objekt noch frei}
    case art of
      0 : exit; {bei ESCAPE}
      1 : ok:=eingabe_punkt(punkte[nr],false); {lies Punkt}
      2 : begin
          gerade:=select_box('Eingabeform der Geraden:','Parameterform','Zwei Punkt','','','');
          case gerade of {je nach Eingabeart}
            1 : ok:=eingabe_gerade(geraden[nr],false);
            2 : ok:=zwei_punkte(geraden[nr]);
          end;
          end;
      3 : begin
          ebene:=select_box('Eingabeform der Ebene :','Paramterform','Normalform',
                            'Koordinatenform','Drei Punkte','');
          case ebene of {je nach Eingabeart}
            1 : ok:=eingabe_ebene(ebenen[nr],false);
            2 : ok:=eingabe_normal(ebenen[nr]);
            3 : ok:=eingabe_ko_form(ebenen[nr]);
            4 : ok:=eingabe_3_punkte(ebenen[nr]);
          end;
          end;
      4 : ok:=eingabe_kugel(kugeln[nr],false);
    end
  else
    begin {wenn kein Objekt mehr frei}
    warnung('Kein weiteres Objekt mglich !');
    exit;
    end;
  if ok then objekte[nr].obj:=art; {Objekt wird bernommen, wenn Eingabe OK}
end;

procedure verandern;
{ Ŀ
  VERANDERN verndert ein bestehendes Objekt.                   
  }
var art,nr:byte;
    ok:boolean;
begin
  status_line('Whlen Sie Objekt zum verndern');
  nr:=select_obj;
  if nr<>0 then
    case objekte[nr].obj of
      1 : ok:=eingabe_punkt(punkte[nr],true);   {Vorgabe hier auf true}
      2 : ok:=eingabe_gerade(geraden[nr],true); {damit alte Werte}
      3 : ok:=eingabe_ebene(ebenen[nr],true);   {bernommen werden}
      4 : ok:=eingabe_kugel(kugeln[nr],true);
    end;
  if not ok then objekte[nr].obj:=0; {lsche Objekt, wenn nicht korrekt}
end;

end.