unit vec_math;
{ Ŀ
  VEC_MATH stellt die mathematischen Funktionen fr die         
  analytischen Berechnung zur Verfgung.                        
  }
interface
uses vec_typs;

function  inraum(v:t_vector):boolean;
function  sreal(s:string):real;
function  rstring(r:real):string;
function  gleich(v1,v2:t_vector):boolean;
procedure v_rot_x(w:real;var v:t_vector);
procedure v_rot_y(w:real;var v:t_vector);
procedure v_rot_z(w:real;var v:t_vector);
function  sgn(x:real):real;
function  id(r1,r2:real):boolean;
procedure v1_sub_v2(v1,v2:t_vector;var v3:t_vector);
procedure v1_add_v2 (v1,v2:t_vector;var v3:t_vector);
procedure normiere(v1:t_vector;lange:real;var v2:t_vector);
function  v1_mul_v2(v1,v2:t_vector):real;
procedure v_mul_n(v1:t_vector;n:real;var v2:t_vector);
procedure v1_x_v2(v1,v2:t_vector;var v3:t_vector); {Vectorprodukt}
function  betrag (v:t_vector):real;
function  determinante (v1,v2,v3 : t_vector):real;
function  lgs2(v0,v1,v2:t_vector;var k1,k2:real):byte;
function  lgs3(v0,v1,v2,v3:t_vector;var k1,k2,k3:real):byte;
function  lgzg(a,b,c:real;var x1,x2:real):byte;
procedure N_2_Ko(n:t_normalform;var ko:t_ko_form);
procedure Ko_2_N(ko:t_ko_form;var n:t_normalform);
procedure E_2_N(e:t_ebene;var n:t_normalform);
procedure N_2_E(n:t_normalform;var e:t_ebene);
function  Linear_ab(v1,v2:t_vector):boolean;
function  SCHNITT_P_P(p1,p2:t_vector):boolean;
function  SCHNITT_P_G(p:t_vector;g:t_gerade):boolean;
function  SCHNITT_P_E(p:t_vector;e:t_ebene):boolean;
function  SCHNITT_P_K(p:t_vector;k:t_kugel):byte;
function  SCHNITT_G_G(g1,g2:t_gerade;var p:t_vector):byte;
function  SCHNITT_G_E(g:t_gerade;e:t_ebene;var v:t_vector):byte;
function  SCHNITT_G_K(g:t_gerade;k:t_kugel;var v1,v2:t_vector):byte;
function  SCHNITT_E_E(e1,e2:t_ebene;var g:t_gerade):byte;
function  SCHNITT_E_K(e:t_ebene;k:t_kugel;var v:t_vector;var radius:real):byte;
function  SCHNITT_K_K(k1,k2:t_kugel;var e:t_ebene; var radius:real):byte;
function  ABSTAND_P_P(p1,p2:t_vector):real;
function  ABSTAND_P_G(p:t_vector;g:t_gerade):real;
function  ABSTAND_P_E(p:t_vector;e:t_ebene):real;
function  ABSTAND_G_G(g1,g2:t_gerade):real;
function  WINKEL_V1_V2(v1,v2:t_vector):real;
function  WINKEL_V_E(v:t_vector;e:t_ebene):real;
procedure Fuss_punkt(p:t_vector;g:t_gerade;var v:t_vector);
procedure spiegle_v2_an_v1(v1,v2:t_vector;var v3:t_vector);

Implementation

function id(r1,r2:real):boolean;
{ Ŀ
  ID(r1,r2:real) vergleicht zwei REAL-Zahlen und lsst eine     
  vorher bestimmt Varianz der Werte zu. (ID=IDENTISCH)          
  }
begin
  id:=abs(r1-r2)<=varianz; {wahr, wenn Differenz kleiner Varianz}
end;

function inraum(v:t_vector):boolean;
{ Ŀ
  INRAUM prft, ob der Vektor V innerhalb der Grafikgrenzen     
  liegt.                                                        
	}
var N:real;
begin
  n:=setup.bereich+varianz;
  with v do
  inraum:=(abs(x)<=n)and(abs(y)<=n)and(abs(z)<=n);
  {wahr, wenn alle 3 Werte kleiner der Bereichsgrenze sind}
end;

function sgn(x:real):real;
{ Ŀ
  SGN berechnet den Signumwert von X.                           
  }
begin
  if x=0 then
    sgn:=0
  else
    if x<0 then
      sgn:=-1
    else
      sgn:=1;
end;

function acos(x:real):real;
{ Ŀ
  ACOS berechnet den Arcuscosinus von X.                        
  }
var y,arccos:real;
begin
   y:=sqrt(1-sqr(x)); {Nutze Satz des Pythagoras}
   if abs(x)<=y then
     arccos:=PI_2-arctan(x/y)
   else
     begin
     arccos:=arctan(y/x);
     if x<0 then arccos:=arccos+pi;
     end;
   acos:=arccos;
end;

function asin(x:real):real;
{ Ŀ
  ACOS berechnet den Arcussinus von X.                          
  }
var y:real;
begin
   y:=sqrt(1-sqr(x)); {hnlich acos}
   if abs(x)<=y then
     asin:=arctan(x/y)
   else
     asin:=sgn(x)*pi_2-arctan(y/x);
end;

procedure v_rot_x(w:real;var v:t_vector);
{ Ŀ
  Lsst einen Vector um die X-Achse um w Bogenma rotieren.     
  }
var a,s,c:real;
begin
  s:=sin(w);
  c:=cos(w);
  a:=v.z;
  v.z:=a*c-v.y*s;
  v.y:=a*s+v.y*c;
end;

procedure v_rot_y(w:real;var v:t_vector);
{ Ŀ
  Lsst einen Vector um die Y-Achse um w Bogenma rotieren.     
  }
var a,s,c:real;
begin
  s:=sin(w);
  c:=cos(w);
  a:=v.x;
  v.x:=a*c-v.z*s;
  v.z:=a*s+v.z*c;
end;

procedure v_rot_z(w:real;var v:t_vector);
{ Ŀ
  Lsst einen Vector um die Z-Achse um w Bogenma rotieren.     
  }
var s,c,a:real;
begin
  s:=sin(w);
  c:=cos(w);
  a:=v.x;
  v.x:=a*c-v.y*s;
  v.y:=a*s+v.y*c;
end;

function sreal(s:string):real;
{ Ŀ
  SREAL(S:String) gibt der REAL-Wert eines String zurck.       
  }
var r:real;
    code:integer;
begin
  val(s,r,code);
  if code=0 then
    sreal:=r  {string enthlt konvertierbare Zahl}
  else
    sreal:=0; {oder auch nicht}
end;

function rstring(r:real):string;
{ Ŀ
  RSTRING(R:Real) liefert einen String der Zahl R zurck.       
  }
var s:string;
begin
  str(r:6:3,s); {formatiere Zahl }
  s[0]:=#6;     {feste Lnge 6}
  rstring:=s;
end;

procedure init_null;
{ Ŀ
  Initalisiert den Nullvector.                                  
  }
begin
  fillchar(null,sizeof(null),0) {setze alles auf 0}
end;

function gleich(v1,v2:t_vector):boolean;
{ Ŀ
  GLEICH prft, ob die beiden Vektoren V1 und V2 gleich sind.   
  }
begin
  gleich:=id(v1.x,v2.x) and id(v1.y,v2.y)and id(v1.z,v2.z); {klar}
end;

procedure v1_sub_v2 (v1,v2:t_vector;var v3:t_vector);
{ Ŀ
  Subtrahiert V2 von V1 und liefert das Ergebnis in V3 zurck.  
  }
begin
  v3.x:=v1.x-v2.x;
  v3.y:=v1.y-v2.y;
  v3.z:=v1.z-v2.z;
end;

procedure v1_add_v2 (v1,v2:t_vector;var v3:t_vector);
{ Ŀ
  Addiert V1 und V2 und liefert das Ergebnis in V3 zurck.      
  }
begin
  v3.x:=v1.x+v2.x;
  v3.y:=v1.y+v2.y;
  v3.z:=v1.z+v2.z;
end;

procedure v_mul_n(v1:t_vector;n:real;var v2:t_vector);
{ Ŀ
  Multipliziert V1 mit der Zahl N und liefert das Ergebnis in   
  V2 zurck.                                                    
  }
begin
  v2.x:=v1.x*n;
  v2.y:=v1.y*n;
  v2.z:=v1.z*n;
end;

function v1_mul_v2(v1,v2:t_vector):real;
{ Ŀ
  V1_MUL_V2 liefert das Skalarprodukt der beiden Vektoren V1 und
  V2 zurck.                                                    
  }
begin
  v1_mul_v2:=v1.x*v2.x + v1.y*v2.y + v1.z*v2.z
end;

procedure v1_x_v2(v1,v2:t_vector;var v3:t_vector);
{ Ŀ
  V1_X_V2 gibt in V3 das Vektorprodukt der beiden Vektoren V1   
  und V2 zurck.                                                
  }
begin
v3.x:=  v1.y*v2.z - v1.z*v2.y;
v3.y:=-(v1.x*v2.z - v1.z*v2.x);
v3.z:=  v1.x*v2.y - v1.y*v2.x;
end;

function betrag (v:t_vector):real;
{ Ŀ
  BETRAG liefert die Lnge des Vektors V zurck.                
  }
begin
betrag:=sqrt(sqr(v.x) + sqr(v.y) + sqr(v.z))
end;

procedure normiere(v1:t_vector;lange:real;var v2:t_vector);
begin
  v_mul_n(v1,lange/sqrt(sqr(v1.x) + sqr(v1.y) + sqr(v1.z)),v2);
end;

function determinante(v1,v2,v3 : t_vector):real;
{ Ŀ
  DETERMINANTE liefert die Determinante einer 3x3 Matrix zurck,
  die aus V1,V2 und V3 besteht.                                 
  }
begin
  determinante:=(v1.x*v2.y*v3.z+v2.x*v3.y*v1.z+v3.x*v1.y*v2.z)-
                (v1.z*v2.y*v3.x+v2.z*v3.y*v1.x+v3.z*v1.y*v2.x)
end;

function lgs2(v0,v1,v2:t_vector;var k1,k2:real):byte;
{ Ŀ
  LGS(Lse-Gleichungs-System) errechnet die 2 Unbekannten K1 und
  K2 aus 3 Gleichungen (V0=V1*K1+V2*k2).                        
  }
var ax,ay,az,bx,by,bz,cx,cy,cz,d,d1,d2:real;
begin
  lgs2:=0;
  with v0 do begin ax:=x;ay:=y;az:=z;end; {spare Tipparbeit}
  with v1 do begin bx:=x;by:=y;bz:=z;end;
  with v2 do begin cx:=x;cy:=y;cz:=z;end;
  if (ax=0)and(bx=0)and(cx=0) then begin
    d:=cz*by-bz*cy;
    d1:=cz*ay-az*cy;
    d2:=az*by-bz*ay;
    if d<>0 then begin
      k1:=d1/d;
      k2:=d2/d;
      lgs2:=1;
      end
    else
      if (d1=0)and (d2=0) then lgs2:=255 else lgs2:=0;
    end
  else
    if (ay=0)and (by=0)and (cy=0) then begin
      d:=bx*cz-bz*cx;
      d1:=ax*cz-az*cx;
      d2:=bx*az-bz*ax;
      if d<>0 then begin
        k1:=d1/d;
        lgs2:=1;
        k2:=d2/d;
        end
      else
        if (d1=0) and (d2=0) then lgs2:=255 else lgs2:=0;
      end
    else
      begin
      d:=cy*bx-by*cx;
      d1:=cy*ax-ay*cx;
      d2:=ay*bx-by*ax;
      if d<>0 then begin
        k1:=d1/d;
        k2:=d2/d;
        if id(az,bz*k1+cz*k2) then lgs2:=1 else lgs2:=0;
        end
      else
        if (d1=0)and(d2=0) then lgs2:=255 else lgs2:=0;
      end;
end;

function lgs3(v0,v1,v2,v3:t_vector;var k1,k2,k3:real):byte;
{ Ŀ
  LGS(Lse-Gleichungs-System) errechnet die 3 Unbekannten K1,K2,
  K3 aus 3 Gleichungen (V0=V1*K1+V2*K2+V3*K3).                  
  }
var d:real;
begin
  lgs3:=0;
  d:=determinante(v1,v2,v3);
  if d<>0 then
    begin
      d:=1/d;
      k1:=determinante(v0,v2,v3)*d;
      k2:=determinante(v1,v0,v3)*d;
      k3:=determinante(v1,v2,v0)*d;
      lgs3:=1;
    end;
end;

function lgzg(a,b,c:real;var x1,x2:real):byte;
{ Ŀ
  LGZG(Lse-Gleichung-Zweiten-Gerades) Lst die Gleichung       
  ax+bx+c=0. Ergebnisse 0=keine Lsung / 1= eine Lsung in x1 /
  2 = zwei Lsungen in x1 und x2.                               
  }
var p,q,d:real; {d=Diskriminante}
begin
  if a=0 then
    begin
      x1:=-c/b; {einfaches umformen}
      lgzg:=1;
    end
  else
    begin
      p:=b/a;
      q:=c/a;
      d:=sqr(p)*0.25-q;
      if d<0 then
        lgzg:=0 {kein Ergebnis}
      else
        if id(d,0) then begin {ein Ergebnis, wenn D=0}
          x1:=-p*0.5;
          lgzg:=1;
          end
        else {ansonsten 2 Ergebnisse}
          begin
          x1:=-p*0.5-sqrt(d);
          x2:=-p*0.5+sqrt(d);
          lgzg:=2;
          end;
    end;
end;

procedure E_2_N(e:t_ebene;var n:t_normalform);
{ Ŀ
  E_2_N wandelt eine Parameterform in eine Normalform um.       
  }
begin
n.a_vector:=e.ansatz;
v1_x_v2(e.richtung1,e.richtung2,n.n_vector);
end;

procedure N_2_E(n:t_normalform;var e:t_ebene);
{ Ŀ
  N_2_E wandelt eine Normalform in Parameterform um.            
  Strategie nutz Fakt, wenn v1 senkrecht zu v2, dann v1*v2=0    
  }
begin
e.ansatz:=n.a_vector;
e.richtung1:=null;
e.richtung2:=null;
if n.n_vector.x<>0 then
  begin
    e.richtung1.x:=-n.n_vector.y/n.n_vector.x;
    e.richtung1.y:=1;
    e.richtung2.x:=-n.n_vector.z/n.n_vector.x;
    e.richtung2.z:=1;
  end
  else if n.n_vector.y<>0 then
    begin
      e.richtung1.x:=1;
      e.richtung1.y:=-n.n_vector.x/n.n_vector.y;
      e.richtung2.y:=-n.n_vector.z/n.n_vector.y;;
      e.richtung2.z:=1;
    end
  else
    begin
        e.richtung1.x:=1;
        e.richtung1.z:=-n.n_vector.x/n.n_vector.z;
        e.richtung2.y:=1;
        e.richtung2.z:=-n.n_vector.y/n.n_vector.z;;
    end;
end;

procedure n_2_ko(n:t_normalform;var ko:t_ko_form);
{ Ŀ
  N_2_KO wandelt eine Normalform in Koordinatenform um.         
  }
begin
  with ko do begin
    x:=n.n_vector.x;
    y:=n.n_vector.y;
    z:=n.n_vector.z;
    k:=-(x*n.a_vector.x+y*n.a_vector.y+z*n.a_vector.z);
  end;
end;

procedure Ko_2_N(ko:t_ko_form;var n:t_normalform);
{ Ŀ
  KO_2_N wandelt eine Koordinatenform in Normalform um.         
  }
begin
  with n.n_vector do begin
    x:=ko.x;
    y:=ko.y;
    z:=ko.z;
  end;
  n.a_vector:=null;
  if ko.x<>0 then
    n.a_vector.x:=-ko.k/ko.x
  else
    if ko.y<>0 then
      n.a_vector.y:=-ko.k/ko.y
    else
      n.a_vector.z:=-ko.k/ko.z;
end;

function linear_ab(v1,v2:t_vector):boolean;
{ Ŀ
  LINEAR_AB prft, ob zwei Vektoren V1 und V2 linear abhngig   
  sind. V1*k=V2                                                 
  }
var rn1,rn2,rn3:real;
    erg,e1,e2,e3 : boolean;
begin
  linear_ab:=false; {ersteimal falsch}
  rn1:=1;rn2:=2;rn3:=3; {damit nicht alle gleich 0 sind}
  e1:=false;e2:=false;e3:=false;
  if (v2.x=0) and (v1.x=0) then
    e1:=true {fr k kann man jeden wert einsezten}
  else
    if (v2.x<>0) then
      rn1:=v1.x/v2.x {damit die X-Zeile richtig ist msste k=rn1 sein}
    else exit; {Divison durch null ist nie gut}
  if (v2.y=0) and (v1.y=0) then  {wie bei x nur mit y}
    e2:=true
  else
    if (v2.y<>0) then rn2:=v1.y/v2.y else exit;
  if (v2.z=0) and (v1.z=0) then  {wie bei x nur mit z}
    e3:=true
  else
    if (v2.z<>0) then rn3:=v1.z/v2.z else exit;
  erg:=true;
  {jetzt vergleiche alle Ergebnisse:}
  if not((((id(rn1,rn2)or e2)and(id(rn1,rn3) or e3)))or e1) then erg:=false;
  if not((((id(rn1,rn3)or e3)and(id(rn2,rn1) or e1)))or e2) then erg:=false;
  if not((((id(rn1,rn1)or e1)and(id(rn3,rn2) or e2)))or e3) then erg:=false;
  linear_ab:=erg;
end;

function ABSTAND_P_P(p1,p2:t_vector):real;
{ Ŀ
  ABSTAND liefert den Abstand zwischen 2 Punkten P1 und P2.     
  }
var ph:t_vector;
begin
  v1_sub_v2(p2,p1,ph);
  abstand_p_p:=betrag(ph);
end;

function ABSTAND_P_E(p:t_vector;e:t_ebene):real;
{ Ŀ
  ABSTAND_P_E liefert den Abstand zwischen einem Punkt und einer
  Ebene.                                                        
  }
var n:t_normalform;
    h:t_vector;
begin
  e_2_n(e,n);
  v_mul_n(n.n_vector,1/betrag(n.n_vector),h); {hessische Normalenform}
  n.n_vector:=h;
  v1_sub_v2(p,n.a_vector,h);
  abstand_P_E:=abs(v1_mul_v2(n.n_vector,h));{abs = Betragsstriche}
end;

function schnitt_p_p(p1,p2:t_vector):boolean;
{ Ŀ
  SCHNITT_P_P prft, ob zwei Punkte P1 und P2 identisch sind.   
  }
begin
  schnitt_p_p:=gleich(p1,p2)
end;

function SCHNITT_P_E(p:t_vector;e:t_ebene):boolean;
{ Ŀ
  SCHNITT_P_E prft, ob ein Punkt P in der Ebene E liegt.       
  }
begin
  if id(abstand_p_e(p,e),0) then
    schnitt_p_e:=true
  else
    schnitt_p_e:=false
end;

function SCHNITT_P_G(p:t_vector;g:t_gerade):boolean;
{ Ŀ
  SCHNITT_P_G prft, ob ein Punkt P auf einer Geraden G liegt.  
  }
var h:t_vector;
begin
  v1_sub_v2(p,g.ansatz,h);
  if linear_ab(h,g.richtung) then
    SCHNITT_P_G:=true
  else
    SCHNITT_P_G:=false;
end;

function  SCHNITT_P_K(p:t_vector;k:t_kugel):byte;
{ Ŀ
  SCHNITT_P_K prft, ob ein Punkt P auf einer Kugel K liegt.    
  Ergebnisse : 0 - Punkt liegt ausserhalb / 1 - Punkt berhrt   
  Kugel / 255 - Punkt liegt in Kugel                            
  }
var ab:real;
begin
  ab:=abstand_p_p(p,k.mitte);
  if id(ab,k.radius) then
    schnitt_p_k:=1
  else if ab<k.radius then
    schnitt_p_k:=255
  else schnitt_p_k:=0;
end;

function SCHNITT_G_G(g1,g2:t_gerade;var p:t_vector):byte;
{ Ŀ
  SCHNITT_G_G prft, ob sich 2 Geraden schneiden. Ergebnisse:   
  0-kein Schnittpunkt / 1-ein Schnittpunkt bei P / 255-Geraden  
  sind identisch.                                               
  }
var h:t_vector;
    d1,d2:real;
    e:byte;
begin
  if linear_ab(g1.richtung,g2.richtung) then
    begin {paralell}
      if schnitt_p_g(g1.ansatz,g2) then
        schnitt_g_g:=255 {identisch}
      else
        schnitt_g_g:=0; {echt parallel}
    end
  else {windschief}
    begin
    p:=null;
    v_mul_n(g1.richtung,-1,h);
    g1.richtung:=h;
    v1_sub_v2(g1.ansatz,g2.ansatz,h);
    e:=lgs2(h,g1.richtung,g2.richtung,d1,d2);
    if e=1 then {geraden schneiden sich}
      begin
      v_mul_n(g1.richtung,-d1,h);
      v1_add_v2(g1.ansatz,h,p); {Berechne schnittpunkt}
      schnitt_g_g:=1;
      end
    else
      schnitt_g_g:=e; {keine Lsung}
    end;
end;

function SCHNITT_G_E(g:t_gerade;e:t_ebene;var v:t_vector):byte;
{ Ŀ
  SCHNITT_G_E prft, ob sich eine Gerade und Ebene schneiden.   
  Ergebnisse 0-kein Schnittpunkt / 1-Schnittpunkt ber V /       
  255 - Gerade liegt auf Ebene (m/n Parameter der Ebene)        
  }
var erg,hilf : t_vector;
    d,k:real;
begin
v1_sub_v2(g.ansatz,e.ansatz,erg);
v_mul_n(g.richtung,-1,hilf);
d:=determinante(e.richtung1,e.richtung2,hilf);
if d<>0 then
  begin
    k:=determinante(e.richtung1,e.richtung2,erg)/d;
    v_mul_n(g.richtung,k,hilf);
    v1_add_v2(hilf,g.ansatz,v);
    schnitt_g_e:=1; {ein schnittpunkt}
  end
else
  begin
  if schnitt_p_e(g.ansatz,e) then
    schnitt_g_e:=255 {kein schnittpunkt}
  else
    schnitt_g_e:=0 {identisch}
  end;
end;

function  SCHNITT_G_K(g:t_gerade;k:t_kugel;var v1,v2:t_vector):byte;
{ Ŀ
  SCHNITT_G_K prft, ob sich eine Gerade und Kugel schneiden.   
  Ergebnisse 0-kein Schnittpunkt / 1-Berhrpunkt bei V1 /       
  255 - 2-Schnittpunkte bei V1 und V2                           
  }
var a,b,c,x1,x2:real;
    hv:t_vector;
    erg:byte;
begin
  a:=sqr(g.richtung.x)+sqr(g.richtung.y)+sqr(g.richtung.z);
  b:=2*((g.ansatz.x-k.mitte.x)*g.richtung.x+
        (g.ansatz.y-k.mitte.y)*g.richtung.y+
        (g.ansatz.z-k.mitte.z)*g.richtung.z);
  c:=sqr(g.ansatz.x-k.mitte.x)+sqr(g.ansatz.y-k.mitte.y)+
     sqr(g.ansatz.z-k.mitte.z)-sqr(k.radius);
  erg:=lgzg(a,b,c,x1,x2);
  case erg of
    1 : begin
        v_mul_n(g.richtung,x1,hv);
        v1_add_v2(hv,g.ansatz,v1);
        end;
    2 : begin
        v_mul_n(g.richtung,x1,hv);
        v1_add_v2(hv,g.ansatz,v1);
        v_mul_n(g.richtung,x2,hv);
        v1_add_v2(hv,g.ansatz,v2);
        end;
  end;
  schnitt_g_k:=erg;
end;


function SCHNITT_E_E(e1,e2:t_ebene;var g:t_gerade):byte;
{ Ŀ
  SCHNITT_E_E prft, ob sich 2 Ebenen schneiden. Ergebnisse:    
  0-Ebenen parallel / 1-eine Schnittgerade G / 255-Ebenen sind  
  identisch.                                                    
  }
var n1,n2:t_normalform;
    gs:t_gerade;
    dummy:byte;
begin
  e_2_n(e1,n1);
  e_2_n(e2,n2);
  if not linear_ab(n1.n_vector,n2.n_vector) then
    begin
      v1_x_v2(n1.n_vector,n2.n_vector,g.richtung);
      gs.ansatz:=n1.a_vector;
      v1_x_v2(g.richtung,n1.n_vector,gs.richtung);
      dummy:=schnitt_g_e(gs,e2,g.ansatz);
      schnitt_e_e:=1;
    end
  else
    if id(abstand_p_e(n1.a_vector,e2),0) then
      SCHNITT_E_E:=255 {e=e da,parallel und ansatz1 in ebene2}
    else
      SCHNITT_E_E:=0;  {e1 echt parallel zu e2}
end;

function  SCHNITT_E_K(e:t_ebene;k:t_kugel;var v:t_vector;var radius:real):byte;
{ Ŀ
  SCHNITT_E_K prft, ob eine Ebene E eine Kugel K schneidet.    
  Ergebnisse : 0 - Ebene schneidet nicht / 1 - Ebene berhrt    
  Kugel / 255 - Ebene schneidet Kugel. RADIUS git den Radius des
  Schnittkreises an.V = Schnittkreismittelpunkt                 
  }
var ab:real;
    g:t_gerade;
begin
  ab:=abstand_p_e(k.mitte,e);
  if id(ab,k.radius) then {Ebene berhrt Kugel}
    begin
    schnitt_e_k:=1;
    radius:=0;
    g.ansatz:=k.mitte;
    v1_x_v2(e.richtung1,e.richtung2,g.richtung);
    if not(schnitt_g_e(g,e,v)=1) then write(#7); {es durfte nie piepsen}
    end
  else if ab<k.radius then {Ebene schneidet Kugel}
    begin
    schnitt_e_k:=255;
    radius:=sqrt(sqr(k.radius)-sqr(ab));
    g.ansatz:=k.mitte;
    v1_x_v2(e.richtung1,e.richtung2,g.richtung);
    if not(schnitt_g_e(g,e,v)=1) then write(#7); {es durfte nie piepsen}
    end
  else schnitt_e_k:=0;
end;

function  SCHNITT_K_K(k1,k2:t_kugel;var e:t_ebene; var radius:real):byte;
{ Ŀ
  SCHNITT_K_K prft, ob sich 2 Kugeln schneiden. Ergebnisse:    
  0-Kein Schnittpunkt / 1-Schnittebene E / 255-Kugeln sind      
  identisch. RADIUS gibt den Radius des Schnittkreises an.      
  }
var ko : t_ko_form;
    n  : t_normalform;
    sp : t_vector;
    g  : t_gerade;
    abstand : real;
begin
  if gleich(k1.mitte,k2.mitte) and id(k1.radius,k2.radius) then
    schnitt_k_k:=255 {kugeln identisch}
  else
    begin
    abstand:=abstand_p_p(k1.mitte,k2.mitte);
    if (abstand<(k1.radius+k2.radius+varianz))and {nicht zu weit weg}
      not((k2.radius>(abstand+k1.radius))or {auch nicht ineinander}
          (k1.radius>(abstand+k2.radius))) then
      begin
      ko.x:=2*(k2.mitte.x-k1.mitte.x);
      ko.y:=2*(k2.mitte.y-k1.mitte.y);
      ko.z:=2*(k2.mitte.z-k1.mitte.z);
      ko.k:=-(sqr(k2.mitte.x)-sqr(k1.mitte.x)+
              sqr(k2.mitte.y)-sqr(k1.mitte.y)+
              sqr(k2.mitte.z)-sqr(k1.mitte.z)+
              sqr(k1.radius)-sqr(k2.radius));
      ko_2_n(ko,n);
      n_2_e(n,e);
      schnitt_k_k:=1;
      g.ansatz:=k1.mitte;
      v1_sub_v2(k2.mitte,k1.mitte,g.richtung);
      if schnitt_g_e(g,e,sp) = 1 then
        begin
        abstand:=abstand_p_p(k1.mitte,sp);
        radius:=sqrt(sqr(k1.radius)-sqr(abstand));
        end;
      end
    else
      schnitt_k_k:=0;{kein Schnittpunkt}
  end;
end;

function ABSTAND_P_G(p:t_vector;g:t_gerade):real;
{ Ŀ
  ABSTAND_P_G berechnet den Abstand zwischen einem Punkt P und  
  einer Geraden G.                                              
  }
var en : t_normalform;
    eh : t_ebene;
    sp : t_vector;
    check:byte;
begin
  en.n_vector:=g.richtung;
  en.a_vector:=p;
  n_2_e(en,eh);
  check:=schnitt_g_e(g,eh,sp);
  if check=1 then
    abstand_p_g:=abstand_p_p(p,sp)
end;

function ABSTAND_G_G(g1,g2:t_gerade):real;
{ Ŀ
  ABSTAND_G_G berechnet den Abstand zwischen zwei Geraden       
  }
var e : t_ebene;
    n : t_normalform;
    v : t_vector;
begin
  if schnitt_g_g(g1,g2,v)=0 then
    begin
      if linear_ab(g1.richtung,g2.richtung) then
        abstand_g_g:=abstand_p_g(g1.ansatz,g2) {geraden parallel}
      else
        begin {geraden windschief}
          v1_x_v2(g1.richtung,g2.richtung,n.n_vector);
          n.a_vector:=g1.ansatz;
          n_2_e(n,e);
          abstand_g_g:=abstand_p_e(g2.ansatz,e);
        end;
    end
  else
    abstand_g_g:=0;{geraden schneiden sich}
end;

function winkel_v1_v2(v1,v2:t_vector):real;
{ Ŀ
  WINKEL_V1_V2 berechnet den Winkel zwischen zwei Vektoren.     
  }
begin
  winkel_v1_v2:=acos(abs(v1_mul_v2(v1,v2)/(betrag(v1)*betrag(v2))));
end;

function winkel_v_e(v:t_vector;e:t_ebene):real;
{ Ŀ
  WINKEL_V_E berechnet den Winkel zwischen Vektor und Ebene.    
  }
var n : t_normalform;
begin
  e_2_n(e,n);
  winkel_v_e:=asin(abs(v1_mul_v2(v,n.n_vector)/(betrag(v)*betrag(n.n_vector))));
end;

procedure fuss_punkt(p:t_vector;g:t_gerade;var v:t_vector);
{ Ŀ
  FUSS_PUNKT rechnet den Punkt auf der Geraden G aus, der den   
  kleinsten Absatnd zu Punkt P hat.                             
	}
var n:t_normalform;
    e:t_ebene;
begin
  n.a_vector:=p;
  n.n_vector:=g.richtung;
  n_2_e(n,e);
  if schnitt_g_e(g,e,v) <> 1 then write(#7);
end;

procedure spiegle_v2_an_v1(v1,v2:t_vector;var v3:t_vector);
{ Ŀ
  SPIEGLE_V2_AN_V1 liefert in V3 den gespiegelten Vektor von V2 
  an V1 zurck.                                                 
	}
var sp,hv: t_vector;
    n:t_normalform;
    e:t_ebene;
    g:t_gerade;
    a:real;
begin
  a:=winkel_v1_v2(v1,v2);
  if (a>0)and(a<pi_2) then
    begin
      g.ansatz:=null;
      g.richtung:=v1;
      n.a_vector:=v2;
      n.n_vector:=v1;
      n_2_e(n,e);
      if schnitt_g_e(g,e,sp)<>1 then write(#7);
      v1_sub_v2(sp,v2,hv);
      v_mul_n(hv,2,hv);
      v1_add_v2(v2,hv,v3);
    end
  else
    v3:=v2;
end;

begin
  init_null;
end.