unit vec_typs;
{ Ŀ
  VEC_TYPS stetzt die Typen und Variabeln fr das Programm fest.
  }
interface
type t_vector = record {der einfache Vector}
       x,y,z:real;
     end;
     t_gerade = record {die Gerade}
       ansatz,richtung : t_vector;
     end;
     t_ebene = record {Ebene in Parameterform}
       ansatz,richtung1,richtung2 : t_vector;
     end;
     t_normalform = record {Ebene in Hessische Normalform}
       n_vector,a_vector : t_vector;
     end;
     t_ko_form = record {Ebene in Koordinatenform}
       x,y,z,k:real {x+y+z+k=0}
     end;
     t_kugel = record {die Kugel}
       mitte  : t_vector;
       radius : real;
     end;
     t_objekt = record {ein Objekt}
       obj : byte;  {0=frei,1=punkt,2=gerade,3=ebene,4=kugel}
       farbe :byte; {farbe des objekts}
     end;
     t_setup = record      {einstellungen im Programm}
       bereich : real;     {Grafikbereich der angezeigt wird um Null}
       box,kreuz,z_buff,grid : boolean; {Grafikoptionen}
       farbmodus : byte;   {1 :individuell, 2 :artabhngig, 3 :s/w}
       obj_name : string;  {Name des aktuellen Vektorraums}
     end;
     t_linie = record {Linie in der Grafik zwischen Vektor a und b}
       a,b:word;
       farbe:byte;
     end;
     t_punkt = record {Punkt bei Vektor p}
       p:word;
       farbe:byte;
     end;
     t_kreis = record {Kugel bei Vektor m mit Radius r(scalar)}
       m:word;
       farbe:byte;
       radius:real;
     end;
     t_g_objekt = record {das 3d-Grafik-Objekt}
       o_vector : array[1..400] of t_vector; {die orginal vectoren}
       r_vector : array[1..400] of t_vector; {die rotierten vectoren}
       frei   : array[1..512] of boolean;  {ist vektor frei}
       linie  : array[1..512] of t_linie;  {die linien}
       punkt  : array[1..128] of t_punkt;  {die punkte}
       kugel  : array[1..128] of t_kreis;  {die kugeln}
       v_anzahl,p_anzahl,l_anzahl,k_anzahl : word; {vector-,punkt-,kugel- und linenanzahl}
     end;
     t_position = record {position bei x,y}
       x,y:word;
     end;

var objekte : array[1..8] of t_objekt;
    punkte  : array[1..8] of t_vector;
    geraden : array[1..8] of t_gerade;
    ebenen  : array[1..8] of t_ebene;
    kugeln  : array[1..8] of t_kugel;
    null    : t_vector; {der Nullvector}
    setup   : t_setup;  {das Programmsetup}
    graphmode : integer;
    pfad,name : string; {Strings fr die Dateiwahl}
    b0,b1,b2,b3  : t_vector;



const varianz =  0.00000001;     {Rechnengenauigkeit}
      PI      =  3.141592653589; {pi}
      PI_2    =  1.570796326794; {pi/2}
      DEG     = 57.29577951;     {180/pi}
      farben1  : array[1..8] of byte = (2,3,9,13,10,11,12,14);
                 {Farbe der 8 Objekte}
      farben2  : array[1..6] of byte = (7,8,4,2,1,15);
                 {Farben fr Kreuz,Box,Punkt,Gerade,Ebene,Kugel}
      grid    = 5; {Anzahl der Linien pro Ebene bei Netzgrafik}
      restlicht =  16;       {diffuses Restlicht beim Raytracer}
      xrange    = 260;       {Projektionsebene 260x200 Pixel}
      yrange    = 200;       {des Raytracers}
      x_step    = 1/xrange;  {Schrittweiten auf der Ebene}
      y_step    = 1/yrange;
      lquelle : t_vector  = (x:3;y:3;z:-3);
      betr0   : t_vector  = (x:0;y:0;z:-1);
      betr1   : t_vector  = (x:0;y:-1;z:-1);
      betr2   : t_vector  = (x:1;y:0;z:-1);


IMPLEMENTATION

end.
