unit vec_vga;
{ Ŀ
  VEC_VGA stellt die Grafikroutinen fr den Raytracer zur       
  Verfgung im 320x200 Pixel 256 Farben VGA-Mode.               
  }
interface

uses dos;

type t_color = record {eine Farbe mit rot,grn,blau Farbanteilen}
       r,g,b:byte;
     end;
     t_palette = array[byte] of t_color; {eine Farbpalette 0..255}

var screen : word; {Adresse des Video-RAMs}
    shaddow : word; {Adresse des Shaddow RAMs}

{Zeiger sind immer auf die Anfnge des Videospeichers bezogen }
procedure init_vga256; {Setzt VGA 320*200 256 Farben Mode 13}
procedure videoswap(zeiger1,zeiger2:word);
procedure setpix(zeiger:word;x,y:word;c:byte);
function  getpix(zeiger:word;x,y:word):byte;
procedure Line(zeiger,x1,y1,x2,y2:word;f:byte);
function  new_screen:word;
procedure box(zeiger,x1,y1,x2,y2:word;color:byte);
procedure SetPal(s,nr:word;var p:t_palette);
procedure print(text:string; zeile,spalte,farbe:byte);
procedure loadpcx(zeiger:word;f:string;var pal:t_palette);
Procedure savepcx(zeiger:word;f:string;pal:t_palette);

Implementation

procedure init_vga256;assembler;
{ Ŀ
  INIT_VGA256 schaltet die VGA-Karte in den 256 Farbenmodus     
  }
asm
  mov ax,19;  {lade Modus 13hex}
  int 10h     {Videointerrupt}
end;

procedure videoswap(zeiger1,zeiger2:word);
{ Ŀ
  Kopiert den Inhalt von Video RAM von Zeiger1 nach Zeiger2     
  }
begin
  move(mem[zeiger1:0],mem[zeiger2:0],64000);
end;

procedure Line(zeiger,x1,y1,x2,y2:word;f:byte);
{ Ŀ
  LINE zieht eine Linie von x1,y1 nach x2,y2 in der Farbe F     
  }
var c,a,b,x,y:word;
begin
    if x2<x1 then {vertausche punkte}
      begin
        a:=x1;  b:=y1;
        x1:=x2; y1:=y2;
        x2:=a;  y2:=b;
      end;
    if y1 > y2 then {fall 1}
      begin
      b:=x2-x1;
      a:=y1-y2;
      c:=0;
      if a>b then begin
        for y:=y1 downto y2 do
          begin
          setpix(zeiger,x1,y,f);
          inc(c,b);
          if c>=a then begin inc(x1);dec(c,a);end;
          end;
        end
      else
        for x:=x1 to x2 do begin
          begin
          setpix(zeiger,x,y1,f);
          inc(c,a);
          if c>=b then begin dec(y1);dec(c,b);end;
          end;
        end;
      end
   else {y1<=y2}
     begin
      b:=x2-x1;
      a:=y2-y1;
      c:=0;
      if a>b then
        for y:=y1 to y2 do
          begin
          setpix(zeiger,x1,y,f);
          inc(c,b);
          if c>=a then begin inc(x1);dec(c,a);end;
          end
      else
        for x:=x1 to x2 do
          begin
          setpix(zeiger,x,y1,f);
          inc(c,a);
          if c>=b then begin inc(y1);dec(c,b);end;
          end;
        end;
end;

function new_screen:word;
{ Ŀ
  Die Funktion NEW_SCREEN liefert die Adresse eines neuen       
  virtuellen Videospeichers (Shaddow RAM)                       
  }
var shaddowptr:pointer;
    calc:longint;
begin
  getmem (shaddowPtr, 320*200 + 15);     {hole freien Speicher}
  calc := seg (shaddowPtr^);
  calc := (calc * 16 + ofs (shaddowPtr^) + 15) div 16; {ofs=0000}
  new_screen:= calc;
end;

procedure setpix(zeiger:word;x,y:word;c:byte);assembler;
{ Ŀ
  SETPIX setzt einen Punkt bei X,Y in Farbe C                   
  }
  asm
    mov ax,y         {hole y}
    mov bx,320
    mul bx           {multipliziere mit 320}
    add ax,x         {addiere x}
    mov es,zeiger    {setze Videoadresse}
    mov cl,c         {hole Farbe}
    mov di,ax
    mov es:[di],cl   {setze Punkt}
  end;

function getpix(zeiger:word;x,y:word):byte;
{ Ŀ
  GETPIX liefert den Farbwert von Punkt X,Y                     
  }
begin
  getpix:=mem[zeiger:320*y+x];
end;

procedure box(zeiger,x1,y1,x2,y2:word;color:byte);
{ Ŀ
  BOX zeichnet einen Kasten von x1,y1 nach x2,y2 in Farbe C     
  }
var segm,offs,d,z :word;
begin
  offs:=x1+320*y1;                       {berechne Ansatzpunkt}
  d:=succ(x2-x1);                        {Lnge einer Zeile}
  for z:=y1 to y2 do begin
    fillchar(ptr(zeiger,offs)^,d,color); {flle Zeile}
    inc(offs,320);                       {eine Zeile runter}
  end;
end;

procedure loadpcx(zeiger:word;f:string;var pal:t_palette);
{ Ŀ
  LOADPCX ldt ein 256-Farben PCX-File mit Namen F ins Video-   
  RAM und seine Farbpalette in PAL                              
  }
  var q : file;
      b : array[0..2047] of byte;
      anz,pos,c,w,h,e,pack,x,y : word;
begin
  assign(q,f);reset(q,1);
  blockread(q,b,128,anz);                 {lese PCX-Header}
  if(b[0]<>10) or(b[3]<>8) then           {prfe PCX ID-Bytes}
    begin close(q); exit end;             {Exit wenn kein PCX-Format}
  w:=succ((b[9]-b[5])*256+b[8]-b[4]);     {berechne Breite}
  h:=succ((b[11]-b[7])*256+b[10]-b[6]);   {berechne Hhe}
  x:=0;                                   {setze X-Anfang}
  y:=0;                                   {setze Y-Anfang}
  pack:=0;c:=0;e:=y+h;
  repeat
    blockread(q,b,2048,anz);              {lese Daten in Puffer}
    pos:=0;                               {setze Pufferzeiger auf 0}
    while(pos<anz) and (y<e) do begin
      if pack<>0 then                     {wenn gepackte Daten...}
        begin
          for c:=c to c+pack do
             mem[zeiger:320*y+c]:=b[pos]; {schreibe Daten in Video RAM}
          pack:=0; end
        else if (b[pos] and $C0)=$c0 then {wenn Byte=Packbyte dann...}
          pack:=b[pos] and $3f            {entcode Packbyte}
          else begin                      {sonst Byte=Datenbyte}
            mem[zeiger:320*y+c]:=b[pos];  {zeichne Datenbyte ein}
            inc(c) end;                   {erhhe X-Position}
          inc(pos);                       {setze Datenzeiger weiter}
          if c=w then                     {wenn Ende einer Zeile}
            begin c:=0; inc(y) end;       {x=0,erhhe Y-Position}
        end;
  until (anz=0) or (y=e);                 {bis Bilddaten zu ende sind}
  seek(q,filesize(q)-3*256-1);            {lese Rest der PCX-Datei}
  blockread(q,b,3*256+1);
  if (b[0]=12) then                       {ist eine Palette vorhanden}
    begin
    for x:=1 to 256*3 do b[x]:=b[x] shr 2;{lese Palette und entcode sie}
    move(b[1],pal,256*3);                 {lade Palette in PAL}
    end;
  close(q);                               {schliesse File}
end;

Procedure savepcx(zeiger:word;f:string;pal:t_palette);
  type t_pcx_head = record
          id  : byte;         {Identifikationsbyte AH}
          ver : byte;         {Versionsbyte 5H}
          RLE : boolean;      {RLE - Codierung ?}
          BPP : byte;         {Bits pro Pixel 8 fr 256 Farben}
          xmin,ymin,
          xmax,ymax : word;   {Koordinaten des Bildes}
          HOR_DPI : word;         {Horizontale Auflsung}
          VER_DPI : word;         {Vertikale Auflsung}
          PAL : array[0..15] of t_color; {16 Farben Palette}
          RES : Byte;         {Reserviert}
          CPL : Byte;         {Anzahl der Farbebenen ColorPLanes}
          BPZ : Word;         {Bytes pro Zeile}
          PDT : Word;         {Palettendaten 1=s/w/COLOR 2=GRAU}
          NIX : string[57];   {Leerbytes}
  end;
  var pixel,pixel2,z : byte;
    xco,yco,lange,schleife : word;
    Datei: file;
    head : t_pcx_head;
  Begin
    assign(datei,f); {ffne Datei}
    rewrite(datei,1);
    fillchar(head,128,0); {lsche header}
    with head do begin {setze Header auf 320x200 256 Farben}
      ID:=$a;
      VER:=5;
      RLE:=true;
      BPP:=8;
      xmin:=0;ymin:=0;
      xmax:=319;ymax:=199;
      CPL:=1;
      BPZ:=320;
      PDT:=1;
      NIX:='VEKTOR 2.0 (C) PRISMA Software 1996';
    end;
    blockwrite(datei,head,sizeof(head)); {schreibe Header}
    yco:=0; {y-Startwert}
    repeat;
      xco:=0; {x-Startwert}
      repeat;
        pixel:=getpix(zeiger,xco,yco); {Lese 1. Pixel}
        lange:=0;                      {Anzahl der Gleichen Pixel}
        repeat; {Suche nach Pixeln gleicher Farbe hintereinander}
          inc(lange);
          pixel2:=getpix(zeiger,xco+lange,yco); {lese nchstes Pixel}
        until (pixel<>pixel2) or (lange=63) or (xco+lange=320);
        inc(xco,lange); {setze x-pos weiter}
        if (lange = 1) and ( pixel <192) then {nur ein Pixel}
          blockwrite(datei,pixel,1);
        if (lange = 1) and ( pixel >191) then {jedoch mit RLE CODE}
          begin
          pixel2:=193;
          blockwrite(datei,pixel2,1);
          blockwrite(datei,pixel,1);
        end;
        if lange > 1 then begin
          pixel2:=lange+192; {setze Codebyte mit Lnge}
          blockwrite(datei,pixel2,1);
          blockwrite(datei,pixel,1);
        end;
      until xco=320; {Bis Zeilenende}
      inc(yco);      {erhhe Zeilennummer}
    until yco=200;   {bis Schirm zuende}
    pixel:=12;
    blockwrite(datei,pixel,1); {Paletten ID Byte}
    for z:=0 to 255 do
      with pal[z] do begin
      r:=r shl 2; {verschiebe Paletteninhalt auf PCX Format}
      b:=b shl 2;
      g:=g shl 2;
      end;
    blockwrite(datei,pal,sizeof(pal)); {Schreibe Palette}
    close(datei); {schliee Datei}
  end;

procedure SetPal(s,nr:word;var p:t_palette);
{ Ŀ
  SETPAL setzt NR Farben aus Palette P von ab Farbe S           
  }
var regs : registers;
  begin
  regs.ah:=$10;            {lade Palettenfunktion}
  regs.al:=$12;            {Funktion : Palette setzen}
  regs.bx:=s;              {Nummer der 1. Farbe}
  regs.cx:=nr;             {Anzahl der Farben}
  regs.es:=seg(p);         {lade Adresse der Palette}
  regs.dx:=ofs(p)+3*s;
  intr($10,regs);          {Videointerrupt}
  end;

procedure print(text:string; zeile,spalte,farbe:byte);
{ Ŀ
  PRINT bring TEXT bei ZEILE,SPALTE in FARBE auf den Schirm     
  }
var lange,ofset,segment:word;
begin
  lange:=length(text);  {Lnge des String}
  ofset:=ofs(text);     {Offset des Strings}
  segment:=seg(text);   {Segment des String}
  asm
    push bp             {sichere BP}
    mov ax,$1301        {lade Stringfunktion nach AX}
		mov bl,farbe        {lade Farbe}
		mov cx,lange        {lade Lnge}
		mov dh,spalte       {lade Spalet}
		mov dl,zeile        {lade Zeile}
    mov es,segment      {lade Adresse}
    mov bp,ofset
    inc bp              {berspring TP Lngen-Byte}
    int $10             {Videointerrupt}
    pop bp              {restore BP}
  end;
end;

begin
  shaddow:=new_screen; {hole Speicher fr Shaddow RAM}
  screen :=$a000; {Setze Adresse des Video RAMs}
end.
