program vector_raum;
uses dos,crt,menufx,vec_typs,vec_math,vec_maus,vec_3dg,
                    vec_mask,vec_ray,vec_poly;
var menu : t_menu;
    titel,befehl : byte;
    dmy:boolean;{dummy}

procedure load_vectors;
{ Ŀ
  LOAD_VECTORS ldt Objekte und Setup aus der Datei NAME.       
  }
var f        : file;
    path,ext,name : string;
begin
  status_line('Whlen Sie die Vektor-Datei');
  name:=dateiwahl('*.VEK',pfad,'Lade Vektoren...'); {hole Dteinamen}
  if name<>'' then begin  {wenn nicht leer,dann}
    fsplit(name,path,setup.obj_name,ext); {hole nur den Namen ohne Pfad}
    setup.obj_name:=setup.obj_name+ext;   {und setze OBJ_NAME so}
    assign(f,name);                       {weise Dateihandle zu}
    reset(f,1);                           {ffne Kanal}
    blockread(f,setup,sizeof(setup));     {lese Daten...}
    blockread(f,objekte,sizeof(objekte));
    blockread(f,punkte,sizeof(punkte));
    blockread(f,geraden,sizeof(geraden));
    blockread(f,ebenen,sizeof(ebenen));
    blockread(f,kugeln,sizeof(kugeln));
    close(f);                            {schliee Kanal}
  end;
end;

procedure save_vectors;
{ Ŀ
  SAVE_VECTORS speichert Objekte und Setup in der Datei NAME.   
  }
var f        : file;
    path,ext,name : string;
begin
  status_line('Geben Sie den Namen der Vektor-Datei an');
  name:=get_string('Speichere Vektoren unter :',setup.obj_name);
  if name<>'' then begin  {wenn nicht leer, dann dito wie Load nur als Save}
    fsplit(name,path,setup.obj_name,ext);
    setup.obj_name:=setup.obj_name+ext;
    assign(f,name);
    rewrite(f,1);
    blockwrite(f,setup,sizeof(setup));
    blockwrite(f,objekte,sizeof(objekte));
    blockwrite(f,punkte,sizeof(punkte));
    blockwrite(f,geraden,sizeof(geraden));
    blockwrite(f,ebenen,sizeof(ebenen));
    blockwrite(f,kugeln,sizeof(kugeln));
    close(f);
  end;
end;

procedure falsche_operation;
{ Ŀ
  FALSCHE_OPERATION zeigt einen Anwenderfehler an.              
  }
begin
  status_line('Diese Operation ist auf die gewhlten Objekte nicht anwendbar');
  textcolor(weiss);textbackground(hellgrau);
  gotoxy(29,13);
  write(' Operation nicht mglich');
end;

procedure abstand_punkt_punkt(p1,p2:t_vector);
{ Ŀ
  ABSTAND_PUNKT_PUNKT zeigt den Abstand zwischen P1 und P2 in   
  dem Fenster an. Alle Folgenden Proceduren sind parallel       
  aufgebaut. Ihre Bezeichnugen sind selbstsprechend.            
	}
var ab:real;
begin
  status_line('Abstand zwischen zwei Punkten');  {zeige akt. Operation an}
  textcolor(weiss);                              {Whle Textfarbe}
  gotoxy(29,13);                                 {gehe ins Ausgabefenster}
  ab:=abstand_p_p(p1,p2);                        {Berechne Operation}
  if ab=0 then                                   {Werte Ergebnis aus}
    write(' Punkte sind identisch')              {Ausgabe...}
  else
    write('Abstand : '+rstring(ab));
end;

procedure schnitt_punkt_punkt(p1,p2:t_vector);
begin
  status_line('Schnitt zwischen Punkt und Punkt');
  textcolor(weiss);
  gotoxy(22,13);
  if schnitt_p_p(p1,p2) then
    write(' Punkte sind identisch')
  else
    write('Punkte sind verschieden');
end;

procedure schnitt_punkt_kugel(p:t_vector;k:t_kugel);
var f:t_fenster;
begin
  status_line('Schnitt zwischen Punkt und Kugel');
  textcolor(weiss);
  gotoxy(22,13);
  case schnitt_p_k(p,k) of
    0 : write('  Punkt liegt ausserhalb der Kugel');
    1 : write('        Punkt berhrt Kugel');
  255 : write('       Punkt liegt in Kugel');
  end;
end;

procedure abstand_punkt_gerade(p:t_vector;g:t_gerade);
var ab:real;
begin
  status_line('Abstand zwischen Punkte und Gerade');
  textcolor(weiss);
  gotoxy(29,13);
  ab:=abstand_p_g(p,g);
  if ab=0 then
    write(' Punkt liegt auf Gerade')
  else
    write('  Abstand : '+rstring(ab));
end;

procedure abstand_punkt_ebene(p:t_vector;e:t_ebene);
var ab:real;
begin
  status_line('Abstand zwischen Punkte und Ebene');
  textcolor(weiss);
  gotoxy(29,13);
  ab:=abstand_p_e(p,e);
  if ab=0 then
    write(' Punkt liegt in der Ebene')
  else
    write('  Abstand : '+rstring(ab));
end;

procedure abstand_gerade_gerade(g1,g2:t_gerade);
var ab:real;
begin
  status_line('Abstand zwischen zwei Geraden');
  textcolor(weiss);
  gotoxy(29,13);
  ab:=abstand_g_g(g1,g2);
  if ab=0 then
    write(' Geraden schneiden sich')
  else
    write('  Abstand : '+rstring(ab));
end;

procedure abstand_ebene_ebene(e1,e2:t_ebene);
var g:t_gerade;
begin
  status_line('Abstand zwischen zwei Ebenen');
  textcolor(weiss);
  gotoxy(29,13);
  case schnitt_e_e(e1,e2,g) of
    0 : write('  Abstand : '+rstring(abstand_p_e(e2.ansatz,e1)));
    1 : write('  Ebenen schneiden sich');
    255 : write('  Ebenen sind identisch');
  end;
end;

procedure abstand_gerade_ebene(g:t_gerade;e:t_ebene);
var v :t_vector;
begin
  status_line('Abstand zwischen Gerade und Ebene');
  textcolor(weiss);
  gotoxy(29,13);
  case schnitt_g_e(g,e,v) of
    0 : write('  Abstand : '+rstring(abstand_p_e(g.ansatz,e)));
    1 : write('  Gerade schneidet Ebene');
    255 : write('  Gerade liegt in Ebene');
  end;
end;

procedure abstand_gerade_kugel(g:t_gerade;k:t_kugel);
var ab :real;
begin
  status_line('Abstand zwischen Gerade und Kugel');
  textcolor(weiss);
  gotoxy(29,13);
  ab:=abstand_p_g(k.mitte,g);
  if ab<=k.radius then
    write('  Gerade schneidet Kugel')
  else
    write('  Abstand : '+rstring(ab-k.radius));
end;

procedure abstand_ebene_kugel(e:t_ebene;k:t_kugel);
var ab :real;
begin
  status_line('Abstand zwischen Ebene und Kugel');
  textcolor(weiss);
  gotoxy(29,13);
  ab:=abstand_p_e(k.mitte,e);
  if id(ab,k.radius) then
    write('  Ebene berhrt Kugel')
  else
    if ab<k.radius then
      write('  Ebene schneidet Kugel')
    else
      write('  Abstand : '+rstring(ab-k.radius));
end;

procedure abstand_punkt_kugel(p:t_vector;k:t_kugel);
var ab :real;
begin
  status_line('Abstand zwischen Punkt und Kugel');
  textcolor(weiss);
  gotoxy(29,13);
  ab:=abstand_p_p(k.mitte,p);
  if id(ab,k.radius) then
    write('  Punkt liegt auf Kugel')
  else
    if ab<k.radius then
      write('  Punkt liegt in Kugel')
    else
      write('  Abstand : '+rstring(ab-k.radius));
end;

procedure abstand_kugel_kugel(k1,k2:t_kugel);
var ab :real;
begin
  status_line('Abstand zwischen zwei Kugeln');
  textcolor(weiss);
  gotoxy(29,13);
  ab:=abstand_p_p(k1.mitte,k2.mitte);
  if ab>(k1.radius+k2.radius) then {keine berhrung}
    write('  Abstand : '+rstring(ab-k1.radius-k2.radius))
  else
    if (k2.radius>(ab+k1.radius))or(k1.radius>(ab+k2.radius)) then
      write('  Kugeln liegen ineinander')
    else
      write('  Kugeln schneiden sich');
end;

procedure schnitt_punkt_gerade(p:t_vector;g:t_gerade);
begin
  status_line('Schnitt zwischen Punkt und Gerade');
  textcolor(weiss);
  gotoxy(22,13);
  if schnitt_p_g(p,g) then
    write('   Punkt ist Element von Gerade    ')
  else
    write('Punkte ist nicht Element von Gerade');
end;

procedure schnitt_punkt_ebene(p:t_vector;e:t_ebene);
var f:t_fenster;
begin
  status_line('Schnitt zwischen Punkt und Ebene');
  textcolor(weiss);
  gotoxy(22,13);
  if schnitt_p_e(p,e) then
    write('   Punkt ist Element von Ebene    ')
  else
    write('Punkte ist nicht Element von Ebene');
end;

procedure schnitt_gerade_gerade(g1,g2:t_gerade);
var p:t_vector;
    erg,nr:byte;
begin
  status_line('Schnitt zwischen Gerade und Gerade');
  textcolor(weiss);
  gotoxy(22,13);
  erg:=schnitt_g_g(g1,g2,p);
  case erg of
    0   : write('  Kein Schnittpunkt der Geraden');
    1   : begin
          write(' Schnittpunkt : ');
          show_vec(p);
          end;
    255 : write('   Geraden sind identisch');
  end;
  if erg = 1 then {es gab einen Schnittpunkt}
    begin
    waitkey;
    nr:=obj_frei; {suche freies Objekt}
    if (nr<>0)and(dialogbox('Schnittpunkt bernehmen ?')) then
      begin {wenn objekt noch frei und Ja vom Anwender, dann...}
        punkte[nr]:=p;      {bernimm Punkt}
        objekte[nr].obj:=1; {es ist ein Punkt}
      end;
    end;
end;

procedure schnitt_gerade_kugel(g:t_gerade;k:t_kugel);
var v1,v2:t_vector;
    erg,nr:byte;
begin
  status_line('Schnitt zwischen Gerade und Kugel');
  textcolor(weiss);
  gotoxy(20,13);
  erg:=schnitt_g_k(g,k,v1,v2);
  case erg of
    0   : write('      Kein Schnittpunkt ');
    1   : begin
          write('   Berhrpunkt : ');
          show_vec(v1);
          end;
    2   : begin
          write('2 Schnittpunkte :');
          show_vec(v1);write(',');
          show_vec(v2);end;
  end;
  if erg = 1 then
    begin
    waitkey;
    nr:=obj_frei;
    if (nr<>0)and(dialogbox('Berhrpunkt bernehmen ?')) then
      begin
        punkte[nr]:=v1;
        objekte[nr].obj:=1;
      end;
    end
  else if erg = 2 then
    begin
    waitkey;
    if dialogbox('Schnittpunkte bernehmen ?') then
      begin
        nr:=obj_frei;
        if nr<>0 then begin
          punkte[nr]:=v1;
          objekte[nr].obj:=1;
          end;
        nr:=obj_frei;
        if nr<>0 then begin
          punkte[nr]:=v2;
          objekte[nr].obj:=1;
          end;
      end;
    end;
end;

procedure schnitt_gerade_ebene(g:t_gerade;e:t_ebene);
var p:t_vector;
    erg,nr:byte;
begin
  status_line('Schnitt zwischen Gerade und Ebene');
  textcolor(weiss);
  gotoxy(23,13);
  erg:=schnitt_g_e(g,e,p);
  case erg of
    0   : write('   Kein Schnittpunkt der Gerade');
    1   : begin
          write(' Schnittpunkt : ');
          show_vec(p);
          end;
    255 : write('   Gerade liegt auf Ebene    ');
  end;
  if erg = 1 then
    begin
    waitkey;
    nr:=obj_frei;
    if (nr<>0)and(dialogbox('Schnittpunkt bernehmen ?')) then
      begin
        punkte[nr]:=p;
        objekte[nr].obj:=1;
      end;
    end;
end;

procedure schnitt_ebene_ebene(e1,e2:t_ebene);
var g:t_gerade;
    erg,nr:byte;
begin
  status_line('Schnitt zwischen Ebene und Ebene');
  textcolor(weiss);
  gotoxy(23,13);
  erg:=schnitt_e_e(e1,e2,g);
  case erg of
    0   : write('     Ebenen sind echt parallel');
    1   : begin
          write('Schnittgerade : ');
          show_vec(g.ansatz);
          write('+k*');
          show_vec(g.richtung);
          end;
    255 : write('     Ebenen sind identisch  ');
  end;
  if erg = 1 then
    begin
    nr:=obj_frei;
    waitkey;
    if (nr<>0)and(dialogbox('Schnittgerade bernehmen ?')) then
      begin
        geraden[nr]:=g;
        objekte[nr].obj:=2;
      end;
    end;
end;

procedure schnitt_kugel_kugel(k1,k2:t_kugel);
var e:t_ebene;
    radius:real;
    erg,nr:byte;
begin
  status_line('Schnitt zwischen zwei Kugeln');
  textcolor(weiss);
  gotoxy(18,12);
  erg:=schnitt_k_k(k1,k2,e,radius);
  case erg of
    0   : write('     Kein Schnittpunkt');
    1   : begin
          write('Schnittebene : ');
          show_vec(e.ansatz);
          write('+k*');
          show_vec(e.richtung1);
          write('+l*');
          show_vec(e.richtung2);
          gotoxy(18,16);
          write('Radius des Schnittkreises :'+rstring(radius));
          end;
    255 : write('     Kugeln sind identisch  ');
  end;
  if erg = 1 then
    begin
    nr:=obj_frei;
    waitkey;
    if (nr<>0)and(dialogbox('Schnittebene bernehmen ?')) then
      begin
        ebenen[nr]:=e;
        objekte[nr].obj:=3;
      end;
    end;
end;

procedure schnitt_ebene_kugel(e:t_ebene;k:t_kugel);
var radius:real;
    v:t_vector;
    erg,nr:byte;
begin
  status_line('Schnitt zwischen Ebene und Kugel');
  textcolor(weiss);
  gotoxy(29,13);
  erg:=schnitt_e_k(e,k,v,radius);
  case erg of
    0   : write('     Kein Schnittpunkt');
    1   : begin
          write('Berhrpunkt : ');
          show_vec(v);
          end;
    255 : begin
          write('mittelpunkt : ');
          show_vec(v);
          gotoxy(29,16);
          write('Schnittkreisradius : '+rstring(radius));
          gotoxy(29,12);
          write('Schnittkreis-');
          end;
  end;
  if erg > 0 then
    begin
    nr:=obj_frei;
    waitkey;
    if (nr<>0)and(dialogbox(' Punkt bernehmen ? ')) then
      begin
        punkte[nr]:=v;
        objekte[nr].obj:=1;
      end;
    end;
end;

procedure lot_punkt_gerade(p:t_vector;g:t_gerade;var l:t_vector);
var e:t_ebene;
    n:t_normalform;
begin
  status_line('Flle Lot von Punkt auf Gerade');
  n.a_vector:=p;
  n.n_vector:=g.richtung;
  n_2_e(n,e);
  if schnitt_g_e(g,e,l)<>1 then write(#7);
end;

procedure lot_punkt_ebene(p:t_vector;e:t_ebene;var l:t_vector);
var g:t_gerade;
    n:t_normalform;
begin
  status_line('Flle Lot von Punkt auf Ebene');
  e_2_n(e,n);
  g.ansatz:=p;
  g.richtung:=n.n_vector;
  if schnitt_g_e(g,e,l)<>1 then write(#7);
end;

procedure lot_punkt_kugel(p:t_vector;k:t_kugel;var l:t_vector);
var g:t_gerade;
    v1,v2:t_vector;
begin
  status_line('Flle Lot von Punkt auf Kugel');
  g.ansatz:=p;
  v1_sub_v2(p,k.mitte,g.richtung);
  if schnitt_g_k(g,k,v1,v2)<>2 then write(#7);
  if abstand_p_p(p,v1)>abstand_p_p(p,v2) then
    l:=v2
  else
    l:=v1;
end;

procedure spiegele_punkt_punkt(p1,p2:t_vector);
var nr:byte;
    p:t_vector;
begin
  status_line('Spiegele Punkt an Punkt');
  textcolor(weiss);
  gotoxy(18,13);
  v1_sub_v2(p1,p2,p);
  v1_add_v2(p1,p,p);
  write('     Spiegelpunkt : ');
  show_vec(p);
  nr:=obj_frei;
  waitkey;
 if (nr<>0)and(dialogbox('Spiegelpunkt bernehmen ?')) then
   begin
   punkte[nr]:=p;
   objekte[nr].obj:=1;
   end;
end;

procedure spiegele_ebene_punkt(e:t_ebene;p:t_vector);
var nr:byte;
    g:t_gerade;
    s,h,sp:t_vector;
    n:t_normalform;
begin
  status_line('Spiegele Punkt an Ebene');
  textcolor(weiss);
  gotoxy(18,13);
  e_2_n(e,n);
  g.ansatz:=p;
  g.richtung:=n.n_vector;
  if schnitt_g_e(g,e,s)<>1 then write(#7);
  v1_sub_v2(s,p,h);
  v1_add_v2(s,h,sp);
  write('     Spiegelpunkt : ');
  show_vec(sp);
  nr:=obj_frei;
  waitkey;
 if (nr<>0)and(dialogbox('Spiegelpunkt bernehmen ?')) then
   begin
   punkte[nr]:=sp;
   objekte[nr].obj:=1;
   end;
end;

procedure spiegele_ebene_gerade(e:t_ebene;g:t_gerade);
var nr:byte;
    sg,hg:t_gerade;
    hp,sp,lp:t_vector;
    n:t_normalform;
begin
  status_line('Spiegele Gerade an Ebene');
  textcolor(weiss);
  gotoxy(18,13);
  e_2_n(e,n);
  if schnitt_g_e(g,e,sp)=1 then
    begin
    v1_add_v2(sp,g.richtung,hp);
    hg.ansatz:=hp;
    hg.richtung:=n.n_vector;
    if schnitt_g_e(hg,e,lp)<>1 then write(#7);
    v1_sub_v2(lp,hp,hp);
    v1_add_v2(lp,hp,lp);
    sg.ansatz:=sp;
    v1_sub_v2(sp,lp,sg.richtung);
    end
  else
    begin
      hg.ansatz:=g.ansatz;
      hg.richtung:=n.n_vector;
      if schnitt_g_e(hg,e,sp)<>1 then write(#7);
      v1_sub_v2(sp,g.ansatz,hp);
      v1_add_v2(sp,hp,sg.ansatz);
      sg.richtung:=g.richtung;
    end;
  write('   Spiegelgerade : ');
  show_vec(sg.ansatz);
  write('+k*');
  show_vec(sg.richtung);
  nr:=obj_frei;
  waitkey;
 if (nr<>0)and(dialogbox('Spiegelgerade bernehmen ?')) then
   begin
   geraden[nr]:=sg;
   objekte[nr].obj:=2;
   end;
end;

procedure spiegele_punkt_gerade(p:t_vector;g:t_gerade);
var nr:byte;
    h:t_vector;
    sg:t_gerade;
begin
  status_line('Spiegele Gerade an Punkt');
  textcolor(weiss);
  gotoxy(18,13);
  v1_sub_v2(p,g.ansatz,h);
  v1_add_v2(p,h,sg.ansatz);
  sg.richtung:=g.richtung;
  write('   Spiegelgerade : ');
  show_vec(sg.ansatz);
  write('+k*');
  show_vec(sg.richtung);
  nr:=obj_frei;
  waitkey;
 if (nr<>0)and(dialogbox('Spiegelgerade bernehmen ?')) then
   begin
   geraden[nr]:=sg;
   objekte[nr].obj:=2;
   end;
end;

procedure spiegele_punkt_ebene(p:t_vector;e:t_ebene);
var nr:byte;
    h:t_vector;
    se:t_ebene;
begin
  status_line('Spiegele Ebene an Punkt');
  textcolor(weiss);
  gotoxy(18,13);
  v1_sub_v2(p,e.ansatz,h);
  v1_add_v2(p,h,se.ansatz);
  se.richtung1:=e.richtung1;
  se.richtung2:=e.richtung2;
  write(' Spiegelebene : ');
  show_vec(se.ansatz);
  write('+k*');
  show_vec(se.richtung1);
  write('+l*');
  show_vec(se.richtung2);
  nr:=obj_frei;
  waitkey;
 if (nr<>0)and(dialogbox('Spiegelebene bernehmen ?')) then
   begin
   ebenen[nr]:=se;
   objekte[nr].obj:=3;
   end;
end;

procedure spiegele_punkt_Kugel(p:t_vector;k:t_kugel);
var x,y,nr:byte;
    h:t_vector;
    sk:t_kugel;
begin
  status_line('Spiegele Kugel an Punkt');
  textcolor(weiss);
  gotoxy(18,13);
  v1_sub_v2(p,k.mitte,h);
  v1_add_v2(p,h,sk.mitte);
  sk.radius:=k.radius;
  write(' Spiegelkugel : ');
  x:=wherex;
  y:=wherey-3;
  gotoxy(x,y+1);
  write('             2');
  gotoxy(x,y+2);
  write('             ');
  gotoxy(x,y+4);
  write('             ');
  gotoxy(x,y+5);
  write('             ');
  gotoxy(x,y+3);
  write(' x - ');
  show_vec(sk.mitte);
  write(' - ('+rstring(sk.radius)+')=0');
  nr:=obj_frei;
  waitkey;
 if (nr<>0)and(dialogbox('Spiegelkugel bernehmen ?')) then
   begin
   kugeln[nr]:=sk;
   objekte[nr].obj:=4;
   end;
end;

procedure winkel_gerade_gerade(g1,g2:t_gerade);
var f:t_fenster;
    w:real;
begin
  status_line('Winkel zwischen zwei Geraden');
  textcolor(weiss);
  gotoxy(29,13);
  w:=deg*winkel_v1_v2(g1.richtung,g2.richtung); {Umrechnung in Grad}
  write('  Winkel : '+rstring(w)+'');
end;

procedure winkel_ebene_ebene(e1,e2:t_ebene);
var f:t_fenster;
    w:real;
    h1,h2:t_normalform;
begin
  status_line('Winkel zwischen zwei Ebenen');
  textcolor(weiss);
  gotoxy(29,13);
  e_2_n(e1,h1);
  e_2_n(e2,h2);
  w:=deg*winkel_v1_v2(h1.n_vector,h2.n_vector);
  write('  Winkel : '+rstring(w)+'');
end;

procedure winkel_gerade_ebene(g:t_gerade;e:t_ebene);
var w:real;
begin
  status_line('Winkel zwischen Gerade und Ebene');
  textcolor(weiss);
  gotoxy(29,13);
  w:=deg*winkel_v_e(g.richtung,e);
  write('  Winkel : '+rstring(w)+'');
end;

procedure schnitt;
{ Ŀ
  SCHNITT lt den Benutzer zwei Objekte whlen und zeigt dann  
  mgliche Schnittpunkte an.                                    
	}
var f : t_fenster;
    obj1,obj2,h:byte;
begin
  status_line('Whlen Sie Objekt 1');
  obj1:=select_obj;                     {Whle obj1}
  status_line('Whlen Sie Objekt 2');
  obj2:=select_obj;                     {whle obj2}
  if objekte[obj1].obj>objekte[obj2].obj then {dann Ringtausch obj1-obj2}
    begin h:=obj2;obj2:=obj1;obj1:=h;end;  {obj1 hat nun die kleinere Nummer}
  with f do begin {Bestimme Ausgabefenster}
    x1:=14;
    y1:=8;
    x2:=x1+50;
    y2:=y1+9;
    v_farbe:=weiss;
    h_farbe:=hellgrau;
    dicke:=2;
    shadow:=true;
  end;
  fensterauf(f); {ffne Ausgabefenster}
  case objekte[obj1].obj of {fr jede Kombination gibt es eine Procedure}
    0: falsche_operation;
    1: case objekte[obj2].obj of
       1 : schnitt_punkt_punkt(punkte[obj1],punkte[obj2]);
       2 : schnitt_punkt_gerade(punkte[obj1],geraden[obj2]);
       3 : schnitt_punkt_ebene(punkte[obj1],ebenen[obj2]);
       4 : schnitt_punkt_kugel(punkte[obj1],kugeln[obj2]);
       end;
    2: case objekte[obj2].obj of
       2 : schnitt_gerade_gerade(geraden[obj1],geraden[obj2]);
       3 : schnitt_gerade_ebene(geraden[obj1],ebenen[obj2]);
       4 : schnitt_gerade_kugel(geraden[obj1],kugeln[obj2]);
       end;
    3: case objekte[obj2].obj of
       3 : schnitt_ebene_ebene(ebenen[obj1],ebenen[obj2]);
       4 : schnitt_ebene_kugel(ebenen[obj1],kugeln[obj2]);
       end;
    4: if objekte[obj2].obj=4 then
          schnitt_kugel_kugel(kugeln[obj1],kugeln[obj2]);
  end;
  waitkey; {Warte auf taste}
  fensterzu(f); {schliee Ausgabefenster wieder}
end;


procedure abstand;
{ Ŀ
  ABSTAND lt den Benutzer zwei Objekte whlen und zeigt dann  
  den Abstand an. Aufbau ist gleich zu SCHNITT.                 
	}
var obj1,obj2,h:byte;
    f:t_fenster;
begin
  status_line('Whlen Sie Objekt 1');
  obj1:=select_obj;
  status_line('Whlen Sie Objekt 2');
  obj2:=select_obj;
  if objekte[obj1].obj>objekte[obj2].obj then begin h:=obj2;obj2:=obj1;obj1:=h;end;
  with f do begin
    x1:=25;
    y1:=10;
    x2:=x1+30;
    y2:=y1+4;
    v_farbe:=weiss;
    h_farbe:=hellgrau;
    dicke:=2;
    shadow:=true;
  end;
  fensterauf(f);
  case objekte[obj1].obj of
    0: falsche_operation;
    1: case objekte[obj2].obj of
       1 : abstand_punkt_punkt(punkte[obj1],punkte[obj2]);
       2 : abstand_punkt_gerade(punkte[obj1],geraden[obj2]);
       3 : abstand_punkt_ebene(punkte[obj1],ebenen[obj2]);
       4 : abstand_punkt_kugel(punkte[obj1],kugeln[obj2]);
       end;
    2: case objekte[obj2].obj of
       2 : abstand_gerade_gerade(geraden[obj1],geraden[obj2]);
       3 : abstand_gerade_ebene(geraden[obj1],ebenen[obj2]);
       4 : abstand_gerade_kugel(geraden[obj1],kugeln[obj2]);
       end;
    3: case objekte[obj2].obj of
       3 : abstand_ebene_ebene(ebenen[obj1],ebenen[obj2]);
       4 : abstand_ebene_kugel(ebenen[obj1],kugeln[obj2]);
       end;
    4: if objekte[obj2].obj=4 then
          abstand_kugel_kugel(kugeln[obj1],kugeln[obj2]);
  end;
  waitkey;
  fensterzu(f);
end;

procedure winkel;
{ Ŀ
  WINKEL lt den Benutzer zwei Objekte whlen und zeigt dann   
  mgliche Schnittwinkel an.Aufbau ist gleich zu Schnitt.       
	}
var f : t_fenster;
    obj1,obj2,h:byte;
begin
  status_line('Whlen Sie Objekt 1');
  obj1:=select_obj;
  status_line('Whlen Sie Objekt 2');
  obj2:=select_obj;
  if objekte[obj1].obj>objekte[obj2].obj then begin h:=obj2;obj2:=obj1;obj1:=h;end;
  with f do begin
    x1:=25;
    y1:=10;
    x2:=x1+30;
    y2:=y1+4;
    v_farbe:=weiss;
    h_farbe:=hellgrau;
    dicke:=2;
    shadow:=true;
  end;
  fensterauf(f);
  case objekte[obj1].obj of {Hier gibt es nicht so viele Mglichkeiten}
    2: case objekte[obj2].obj of
       2 : winkel_gerade_gerade(geraden[obj1],geraden[obj2]);
       3 : winkel_gerade_ebene(geraden[obj1],ebenen[obj2]);
       else falsche_operation;
       end;
    3: if objekte[obj2].obj=3 then
         winkel_ebene_ebene(ebenen[obj1],ebenen[obj2])
       else falsche_operation;
  else
       falsche_Operation;
  end;
  waitkey;
  fensterzu(f);
end;

procedure lotfusspunkt;
var f : t_fenster;
    obj1,obj2,h:byte;
    fusspunkt:t_vector;
    fehler:boolean;
begin
  fehler:=false;
  status_line('Whle Punkt, von dem das Lot gefllt wird');
  obj1:=select_obj;                     {Whle obj1}
  if objekte[obj1].obj<>1 then begin
    status_line('Gewhltes Objekt ist kein Punkt !');
    waitkey;
    exit;
  end;
  status_line('Whle Objekt 2, als Basis fr das Lot ');
  obj2:=select_obj;                     {whle obj2}
  with f do begin {Bestimme Ausgabefenster}
    x1:=22;
    y1:=8;
    x2:=x1+40;
    y2:=y1+8;
    v_farbe:=weiss;
    h_farbe:=hellgrau;
    dicke:=2;
    shadow:=true;
  end;
  fensterauf(f); {ffne Ausgabefenster}
  case objekte[obj2].obj of
     1 : fehler:=true;
     2 : lot_punkt_gerade(punkte[obj1],geraden[obj2],fusspunkt);
     3 : lot_punkt_ebene(punkte[obj1],ebenen[obj2],fusspunkt);
     4 : lot_punkt_kugel(punkte[obj1],kugeln[obj2],fusspunkt);
  end;
  if fehler then
    begin
    falsche_operation;
    waitkey;
    end
  else
    begin
    textbackground(hellgrau);
    textcolor(weiss);
    gotoxy(29,13);
    write('Lotfupunkt bei : ');
    show_vec(fusspunkt);
    h:=obj_frei;
    waitkey;
    if (h<>0)and(dialogbox('Lotfupunkt bernehmen ?')) then
      begin
        punkte[h]:=fusspunkt;
        objekte[h].obj:=1;
      end;
    end;
  fensterzu(f); {schliee Ausgabefenster wieder}
end;

procedure spiegelbild;
var f : t_fenster;
    obj1,obj2,h:byte;
begin
  status_line('Whle Punkt oder Ebene als Spiegelbasis  ');
  obj1:=select_obj;                     {Whle obj1}
  if (objekte[obj1].obj<>1)and(objekte[obj1].obj<>3) then begin
    status_line('Gewhltes Objekt ist kein Punkt oder Ebene !');
    waitkey;
    exit;
  end;
  status_line('Whle Objekt 2, das gespiegelt werden soll ');
  obj2:=select_obj;                     {whle obj2}
  with f do begin {Bestimme Ausgabefenster}
    x1:=14;
    y1:=8;
    x2:=x1+50;
    y2:=y1+8;
    v_farbe:=weiss;
    h_farbe:=hellgrau;
    dicke:=2;
    shadow:=true;
  end;
  fensterauf(f); {ffne Ausgabefenster}
  case objekte[obj1].obj of
    1: case objekte[obj2].obj of
       1 : spiegele_punkt_punkt(punkte[obj1],punkte[obj2]);
       2 : spiegele_punkt_gerade(punkte[obj1],geraden[obj2]);
       3 : spiegele_punkt_ebene(punkte[obj1],ebenen[obj2]);
       4 : spiegele_punkt_kugel(punkte[obj1],kugeln[obj2]);
       else
         falsche_operation;
       end;
    3: case objekte[obj2].obj of
       1 : spiegele_ebene_punkt(ebenen[obj1],punkte[obj2]);
       2 : spiegele_ebene_gerade(ebenen[obj1],geraden[obj2]);
       3 : ;
       4 : ;
       else
         falsche_operation;
       end;
    else  falsche_operation
  end;
  waitkey;
  fensterzu(f); {schliee Ausgabefenster wieder}
end;

procedure grafik;
var rotx,roty,rotz,ax,ay,az:real;
{ Ŀ
  GRAFIK zeigt den Vektorraum in 3D-Form und verarbeitet die    
  Rotationen, die durch die Maus gesteuert werden.              
	}
begin
  rotx:=0; roty:=0; rotz:=0;
  b0:=betr0; b1:=betr1; b2:=betr2; b3:=lquelle;
  v_shaddow:=v_ram;                       {Sichere Menubildschirm}
  status_line('Berechne 3D-Grafik...');   {Info fr Benutzer}
  create_obj;                             {erstelle 3D-Grafikobjekt}
  check_obj;                              {prfe und optimiere das Objekt}
  init_show;                              {bereite Grafikausgabe vor}
  repeat
    if setup.z_buff then z_sort;    {Wenn z-Buffering gewhlt, sortiere}
    show_g_obj(rotx,roty,0);                           {Zeichne das Grafikobjekt}
    set_mouse;                            {Setzte Maus auf 200/200}
    repeat
      mouse_status;                       {Hole Mausdaten}
    {wiederhole bis Maus bewegt und Taste gedrckt wurde}
    until (xco<>200) or (yco<>200) or keypressed;
    rotx:=rotx+(yco-200)*0.01;
    roty:=roty+(xco-200)*0.01;
    if rotx>pi_2 then rotx:=pi_2;
    if rotx<-pi_2 then rotx:=-pi_2;
  until keypressed;                       {Grafik bis Tastaturtaste gedrckt}
  v_rot_x(-rotx,b0);
  v_rot_x(-rotx,b1);
  v_rot_x(-rotx,b2);
  v_rot_x(-rotx,b3);
  v_rot_y(-roty,b0);
  v_rot_y(-roty,b1);
  v_rot_y(-roty,b2);
  v_rot_y(-roty,b3);
  if readkey=#13 then trace;
  menufx_init;                            {Menumodus einstellen}
  cursoraus;                              {Cursor ausblenden}
  v_ram:=v_shaddow;                       {Menu wieder herstellen}
end;

procedure const_menu;
{ Ŀ
  Stellt Variabeln auf einen Startwert und richtet das Men ein.
	}
begin
  del_menu(menu);    {Lsche Menu}
  with menu do begin
    leiste[0].titel:=' DATEI ';
    leiste[0].befehl[0]:=' Lade Vektoren';
    leiste[0].befehl[1]:=' Neue Vektoren';
    leiste[0].befehl[2]:=' Speichere Vektoren ';
    leiste[0].befehl[3]:=' Programm Info';
    leiste[0].befehl[4]:=' Beende Programm ';
    leiste[1].titel:=' OBJEKTE ';
    leiste[1].befehl[0]:=' Objekt einfgen ';
    leiste[1].befehl[1]:=' Objekt verndern ';
    leiste[1].befehl[2]:=' Objekt lschen';
    leiste[2].titel:=' OPERATIONEN ';
    leiste[2].befehl[0]:=' Schnitt ';
    leiste[2].befehl[1]:=' kleinster Abstand  ';
    leiste[2].befehl[2]:=' kleinster Winkel   ';
    leiste[2].befehl[3]:=' Lotfusspunkt';
    leiste[2].befehl[4]:=' Spiegele Objekt   ';
    leiste[3].titel:=' GRAFIK ';
    leiste[3].befehl[0]:=' 3D-Anzeige ';
    leiste[3].befehl[1]:=' Zeige Bild ';
    leiste[3].befehl[2]:=' Lade Bild ';
    leiste[3].befehl[3]:=' Speichere Bild ';
    leiste[3].befehl[4]:=' Farben ';
    leiste[3].befehl[5]:=' Grafikbereich ';
    leiste[3].befehl[6]:=' Optionen... ';
  end;
  titel:=0;  {akt. Menposition...}
  befehl:=0;
  gotoxy(1,1);  {zeichen Menubildschirm...}
  textcolor(schwarz);
  textbackground(hellgrau);
  block(0,0,79,23,32,gelb,blau);
  rahmen(0,1,79,23,2,weiss,blau);
  block(0,0,79,0,32,schwarz,hellgrau);
  block(0,24,79,24,32,schwarz,hellgrau);
  write(' DATEI  OBJEKTE  OPERATIONEN  GRAFIK'); {Menleiste}
  cursoraus;
end;

procedure ende_vec;
{ Ŀ
  ENDE_VEC beendet das Programm.                                
	}
begin
  textbackground(schwarz);
  textcolor(hellgrau);
  clrscr;
  writeln('VEKTOR 2.0 (C) 1996 PRISMA Software  Martin Otten');
  cursornormal;
  halt;
end;

begin {das Hauptprogramm}
  clrscr;               {lsche Schirm}
  menufx_init;          {Menumodus}
  const_menu;           {Erstelle Menu}
  getdir(0,pfad);       {Hole aktuellen Pfad}
  del_vec_raum;         {Lsche Vektorraum}
  info_box;             {zeige Infobox}
  repeat
    show_all_obj;       {zeige alle Objekte}
    show_obj_name;      {zeige Projektname}
    status_line('Whlen Sie nchsten Befehl im Menu');
    get_menu(menu,titel,befehl); {hole nchsten Befehl}
    case titel of       {werte Befehl aus}
      0 : case befehl of {Datei}
          0 : load_vectors;{Lade Datei}
          1 : begin {neuer Vektorraum}
              status_line('Es werden alle Objekte gelscht');
              if dialogbox(' Alle Objekte lschen ? ') then
                del_vec_raum;
              end;
          2 : save_vectors;{speichere Daten}
          3 : info_box; {infobox}
          4 : begin  {programm beenden}
              status_line('Programm ohne speichern beenden');
              if dialogbox('  Programm beenden ?  ') then ende_vec;
              end;
          end;
      1 : case befehl of  {Objekte}
          0 : einfugen;
          1 : verandern;
          2 : loschen;
          end;
      2 : share_box;
      3 : case befehl of  {Grafik}
          0 : grafik;
          4 : begin
              status_line('Whlen Sie Farbdarstellung in der Grafik');
              setup.farbmodus:=select_box('Farben der Objekte :','unterschiedlich',
                            'je nach Objektart','schwarz/weiss','','');
              end;

          5 : eingabe_bereich; {lese neuen Grafikbereich}
          6 : begin
              status_line('Setzten Sie die Grafikeinstellungen mit der Leertaste');
              with setup do option_box(box,kreuz,z_buff,grid,dmy,'Grafik-Optionen : ','Bereichsgrenzen',
                                        'Koordinatenkreuz','Z-Buffering','Netzgrafik','',4);
              end;
          7 : ;
          1 : begin
              v_shaddow:=v_ram;
              show_trace;
              waitkey;
              menufx_init;
              cursoraus;
              v_ram:=v_shaddow;
              end;
          2 : begin
              name:=dateiwahl('*.PCX',pfad,'Lade Standbild...');
              if name<>'' then begin
                v_shaddow:=v_ram;
                status_line('Lade Bild '+name+'...');
                load_trace(name);
                waitkey;
                menufx_init;
                cursoraus;
                v_ram:=v_shaddow;
                end;
              end;
          3 : begin
              name:=get_string('Speichere Bild unter :','STANDBLD.PCX');
              if name<>'' then begin
                gross(name);
                status_line('Speicher Bild in '+name+'...');
                save_trace(name);
                end;
              end;
          end;
    end;
  until false; {Endlosschleife}
end.
